/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.common;

import java.util.Iterator;
import java.util.Vector;

import org.objectweb.util.browser.core.api.TypeKey;
import org.objectweb.util.browser.core.api.TypeSystem;
import org.objectweb.util.browser.core.api.TypeSystemHandler;

/**
 * Basic implementation of TypeSystemHandler.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class DefaultTypeSystemHandler 
    implements TypeSystemHandler {

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================

    protected Vector elements_ = new Vector();

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for TypeSystemHandler interface.
    //
    //==================================================================

    /**
     * The type system to add
     * @param typeSystem
     */
    public void
    addTypeSystem(TypeSystem typeSystem)
    {
        elements_.add(typeSystem);
    }

    /**
     * Provides the key associated to the given class
     * @param theClass The class to decode
     * @return The associated key
     */
    public TypeKey
    getTypeKey(Class theClass)
    {
        for (Iterator iter = elements_.iterator(); iter.hasNext();) {
            TypeSystem element = (TypeSystem) iter.next();
            TypeKey typeKey = element.getTypeKey(theClass);
            if(typeKey!=null)
                return typeKey;
        }    
       return null;
    }

}    