/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.common;

/** The application's imports */
import org.objectweb.util.browser.core.api.TargetPanel;
import org.objectweb.util.browser.core.panel.WhitePanel;
import org.objectweb.util.browser.api.Panel;

/** The java API's imports */
import java.awt.GridLayout;
import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * This class defines the view panel. 
 * This one contains ans displays the panel assocites to a node.
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class DefaultViewPanel 
    extends JPanel 
    implements TargetPanel {

    protected Panel panel_ = null;

    /**
     * Default constructor
     */
    public DefaultViewPanel() {
        setLayout(new GridLayout(1, 0));
        setPreferredSize(new Dimension(400, 500));
        add(new JScrollPane((new WhitePanel()).getPanel()));
    }

    /**
     * Fixes the panel associated to the selected node
     */
    public void setViewPanel(Panel newPanel) {
        removeAll();
        panel_ = newPanel;
        JScrollPane viewScrollPane = new JScrollPane(panel_.getPanel());
        add(viewScrollPane);
        validate();
    }

    /**
     * Returns the current panel.
     * @return The current displayed panel
     */
    public Panel getViewPanel(){
        return panel_;
    }

}
