/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.naming;

/** To use the LinkedList class. */
import java.util.LinkedList;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class SpecificList 
    extends LinkedList {
	
    // ==================================================================
    //
    // No internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // No constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // No internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // No public methods.
    //
    // ==================================================================

    private class Elem {

        /** The associated Class */
        protected Class class_;

        /** The associated level */
        protected int level_;

        /**
         * Default contructor 
         */
        public Elem(Class class_, int level_) {
            this.class_ = class_;
            this.level_ = level_;
        }

        /**
         * Returns the class_.
         * @return Class
         */
        public Class getClass_() {
            return class_;
        }

        /**
         * Returns the level_.
         * @return int
         */
        public int getLevel_() {
            return level_;
        }

    }

}
