/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 27 juin 2003
 *
 */
package org.omg.lifl.eclipse.plugin.utils;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.PrintWriter;

public class StreamCatcher extends Thread {
    public boolean err_done;
    public InputStream is;
    public PrintStream os;
    public String type;

    public StreamCatcher(InputStream is, String type) {
        os = null;
        err_done = false;
        this.is = is;
        this.type = type;
    }

    public StreamCatcher(InputStream is, PrintStream os, String type) {
        this.os = null;
        err_done = false;
        this.is = is;
        this.os = os;
        this.type = type;
    }

    public void set_err_done(boolean done)
    {
        err_done = done;
    }

    public void run()
    {
        try
        {
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            PrintWriter pw = null;
            if(os != null)
                pw = new PrintWriter(os);
            String line = null;
            if(type.compareTo("ERROR") == 0)
                while((line = br.readLine()) != null) 
                {
                    if(pw != null)
                        pw.println(line);
                    System.out.println("[OPENCCM]" + type + ">" + line);
                    OutputToConsole.addError(line + "\n");
                }
            else
            if(type.compareTo("OUTPUT") == 0)
                while((line = br.readLine()) != null) 
                {
                    if(pw != null){
                        //System.out.println("[DEBUG] pw");
                        pw.println(line);
                    }
                    //else System.out.println("[DEBUG] pas de pw");
                    System.out.println("[OPENCCM]" + type + ">" + line);
                    if(line.indexOf(": error:") > 0 || line.indexOf(" error, ") > 0)
                        OutputToConsole.addError(line + "\n");
                    else
                        OutputToConsole.addOutString(line + "\n");
                }
        }
        catch(IOException ioe)
        {
            ioe.printStackTrace();
        }
    }

    }
