@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Romain Rouvoy.
rem # Contributor(s): Philippe Merle.
rem #
rem # ====================================================================
rem #
rem # Starting the Community OpenORB 1.4.0 CosTransactions Service.
rem #
rem # ====================================================================

setlocal

rem # Check if the CosTransactions Service is already started.
if not exist %OpenCCM_CONFIG_DIR%\TransactionService.IOR goto :not_exist

echo Error: The CosTransactions Service is already started!
goto :eof

:not_exist

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

:do_start

echo The CosTransactions Service will be started.

rem # Remove the TransactionFactory.ior file
rem # else the following while instruction
rem # could consider that the CosTransactions Service
rem # is started and this is not the case
rem # if the file was already present.
if exist TransactionFactory.ior del TransactionFactory.ior

echo Launching The Community OpenORB 1.4.0 CosTransactions Service.

call launcher fork "" "%OpenCCM_HOMEDIR%/xml/launcher/OTS.xml" %OpenCCM_CONFIG_DIR%\TransactionService.output %OpenCCM_CONFIG_DIR%\TransactionService.PID

rem # Wait for the TransactionFactory.ior file produced
rem # by the Community OpenORB 1.4.0 CosTransactions Service.
:wait
set READY=
if not exist TransactionFactory.ior goto :wait
for /f %%i in (TransactionFactory.ior) do set READY=ok
if not defined READY goto :wait

rem # Move it into the OpenCCM configuration directory.
move TransactionFactory.ior %OpenCCM_CONFIG_DIR%\TransactionService.IOR

echo The CosTransactions Service is started.
