/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package DiningPhilosophers.browser;

/** The browser's imports */
//import org.objectweb.util.browser.api.ExtendedActionEvent;
//import org.objectweb.util.browser.api.ExtendedActionListener;
//import org.objectweb.util.browser.gui.core.ClassResolver;

/** The Java API's imports */
import javax.swing.JOptionPane;

/** Others imports */
import org.omg.Components.CreateFailure;
import DiningPhilosophers.PhilosopherHome;

import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;

/**
 * This action allows to create a philisopher with a specific name.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class PhilosopherCreationAction 
    implements MenuItem {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    //
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for MenuItem interface.
    //
    //==================================================================

    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }
    
    public void actionPerformed(MenuItemTreeView e) throws Exception {
        String name = "";
        while (name != null && name.equals("")) {
            name = JOptionPane.showInputDialog("Enter the philosopher's name:");
        }
        if(name!=null){
            PhilosopherHome philosopherHome = (PhilosopherHome) e.getSelectedObject();
            philosopherHome._new(name);
        }
    }

}
