/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet.
Contributor(s): Philippe Merle.

====================================================================*/

package org.objectweb.ccm.Containers;

/**
 * This interface ??????.
 *
 * @author <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class ComponentCallContext
       extends CallContextBase
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

// Added for Bug #466.
// Contributor: Philippe Merle

    /** To store a reference to the associated component. */
    protected org.objectweb.ccm.Components.CCMObjectImpl the_component_ = null;

// Add end.

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The constructor.
     **
     **/
    public
    ComponentCallContext(HomeServant home_servant,
			 java.lang.String uid)
    {
        super(home_servant, uid);
    }

// Added for Bug #466.
// Contributor: Philippe Merle

    /**
     * The constructor.
     *
     * TODO: Add Javadoc comments.
     */
    public
    ComponentCallContext(ComponentServant component_servant,
                         HomeServant home_servant,
			 java.lang.String uid)
    {
        super(home_servant, uid);
        the_component_ = ((org.objectweb.ccm.Components.CCMObjectImpl)component_servant.the_component_executor());
    }

// Add end.

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     **
     **/
    protected SystemConfiguration
    getConfiguration()
    {
        return the_home_servant_.the_component_configuration();
    }

// Added for Bug #466.
// Contributor: Philippe Merle

    // ==================================================================
    //
    // Public methods for the CallContext interface.
    //
    // ==================================================================

    /**
     *
     */
    public CallContext
    duplicate(java.lang.String op_name)
    {
        // If this context is not the context of the main component interface
        // then this is the context of a facet or event sink port.
        //
        String the_component_uid = the_home_servant_.the_home_executor()._the_component_uid();
        if(!the_component_uid.equals(the_uid_))
        {
            // Then waits until configuration_complete is called on the component.
            if(the_component_ != null)
                the_component_.wait_until_configuration_complete();
        }

        return super.duplicate(op_name);
    }

// Add end.

}
