/*====================================================================

created on 11 mars 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

/**
 * @author hameau
 */
public class HomeTypeImpl
extends TypeImpl 
implements HomeType {

  // internal parameters
  
  protected ContainerType     _container_type;
  protected InterfaceTypeList _supported_interfaces;
  protected AttributeTypeList _attribute_type_list;
  protected InterfaceType     _equivalent_interface;
  
  /**
   * 
   */
  public HomeTypeImpl() 
  {
    _container_type = null;
    _equivalent_interface = null;
    _supported_interfaces = new InterfaceTypeListImpl();
    _attribute_type_list  = new AttributeTypeListImpl();
  }
  
    public ContainerType container_type()
  {
  	return _container_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.HomeTypeOperations#supported_interfaces()
   */
  public InterfaceTypeList supported_interfaces()
  {
    return _supported_interfaces;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.HomeTypeOperations#attribute_type_list()
   */
  public AttributeTypeList attribute_type_list()
  {
    return _attribute_type_list;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.HomeTypeOperations#create_home_instance()
   */
  public HomeInstance create_home_instance()
  {
    // creating a new 'empty' home instance 
    
    HomeInstance _tmp_home_inst = new HomeInstanceImpl();
    
    // fill its attribute
    
    // related instance kind is component instance 
    _tmp_home_inst.related_instance_kind(instance_kind.COMPONENT_INSTANCE);
    
    // TODO reference must be set afterwards !!!
    _tmp_home_inst.home_ref(null);
    // link to its home type
    _tmp_home_inst.type_reference(this);
    
  //  System.err.println("### DEBUG home instance created for " + this._name);
   
    return _tmp_home_inst;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.HomeTypeOperations#equivalent_interface()
   */
  public InterfaceType equivalent_interface()
  {
    return _equivalent_interface;
  }

 }
