/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc
Contributor(s): ___________________________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm;

// Local Interface Import Statements
import org.objectweb.apollon.framework.Extension;

/**
 * Handle the "ccm.Deployer" extension of the
 * <code>Registerwithtrader</code> bean.
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 *
 * @version 0.1
 */ 
public class RegisterwithtraderDeployerHandler extends Extension {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The deployer extension */
    private RegisterwithtraderDeployer _deploy;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Construct a new <code>Registerwithtrader</code> "Deployer"
     * extension.
     */
    public RegisterwithtraderDeployerHandler() {
        _deploy = new RegisterwithtraderDeployer();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Returns the instance of the managed extension.
     *
     * @return The managed extension.
     */
    public Object getInstance() {
        return (_deploy);
    }

    /**
     * Returns the name of the managed extension. 
     * Here it returns "Deployer".
     *
     * @return The "Deployer" string.
     */
    public String toString() {
        return("ccm.Deployer");
    }
}
