/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.ccm.descriptor.softpkg.ccm;

//import the needed packages
import org.objectweb.ccm.descriptor.softpkg.*;
import org.objectweb.ccm.descriptor.softpkg.beans.*;

/**
 * HomeplacementDeployer install a dependency archive.
 *
 * @author <a href="mailto:frederic.briclet@lifl.fr">Briclet Frederic</a>
 *
 * @version 0.1
 */
public class DependencyDeployer {
    
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     * Resolve a depency.
     * @param deployTable the internal table use to store information.
     * @param server_inst The ComponentInstallation to use to install the 
     * dependency archive
     * @param dep The dependency to resolve
     */
    public void
    resolveDependency(java.util.Hashtable deployTable,
                      org.omg.Components.Deployment.ComponentInstallation server_inst,
                      Dependency dep)
        throws java.io.IOException,
               org.omg.Components.Deployment.InvalidLocation,
               org.omg.Components.Deployment.InstallationFailure
    {
        
        if (dep.getAction().equals("install")
            && (dep.getFileinarchive()!=null)
            && (dep.getFileinarchive().getName()!=null)
            && (dep.getName()!=null)
            && (dep.getName().getValue()!=null)
            )
            {  
                /* file=new java.io.File(dep.getFileinarchive().getName());
                   if(file.exists())
                   absolutePath=file.getCanonicalPath();
                   else absolutePath=dep.getFileinarchive().getName();
                   server_inst.install(dep.getName().getValue(),
                   absolutePath);                         */
                /*java.util.zip.ZipFile zf=
                  (java.util.zip.ZipFile)deployTable.get("__car_zip__");
                  java.io.InputStream is= 
                  zf.getInputStream
                  (zf.getEntry(dep.getFileinarchive().getName().trim()));
                  
                  
                  (new Thread
                  (new  org.objectweb.ccm.deploytool.MicroServerHttp
                  (serverSocket,is,dep.getFileinarchive().getName().trim()))).start();
                */
                                /* file=new java.io.File(dep.getFileinarchive().getName());
                                   if(file.exists())
                                   absolutePath=file.getCanonicalPath();
                                   else absolutePath=dep.getFileinarchive().getName();
                                */
                org.objectweb.ccm
                    .descriptor.softpkg
                    .beans.FileinarchiveBean current=
                    (org.objectweb.ccm.
                     descriptor.softpkg
                     .beans.FileinarchiveBean) 
                    dep.getFileinarchive();
            
                
                String fileAdress =
                    ((FileinarchiveDeployer)
                     current
                     .getExtensionManager()
                     .getExtensionByName("ccm.Deployer")
                     .getInstance())
                    .startHttpServer(deployTable,dep.getFileinarchive());                
                
                server_inst.install
                    (dep.getName().getValue(),fileAdress);
                                /*server_inst.install(dep.getName().getValue(),
                                  absolutePath);                         */
            }
    }

}
