/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the OpenCCM_DCI::AssemblyManagerMoedl
 * component type.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class AssemblyManagerModelImpl
     extends org.objectweb.openccm.OpenCCM_DCI.
             AssemblyManagerModelSessionComposition.AssemblyManagerModelImpl
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    //The XML descriptor ressource 
    private String xml_descriptor;
    // The assembly uuid
    private String assemblyUUID;
    //Private boolean state
    private boolean removed;
    
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    public AssemblyManagerModelImpl(String xml_descriptor){
        this.xml_descriptor=xml_descriptor;   
        //Build an assembly uuid
        assemblyUUID=System.currentTimeMillis()+"";
        assemblyUUID.substring(assemblyUUID.length()-5,assemblyUUID.length());
        assemblyUUID="AAM"+assemblyUUID;           
    }
    
    // ==================================================================
    //
    // Accessor methods
    //
    // ==================================================================
    public String xml_descriptor(){       
        return xml_descriptor;
    }
    
    public String assemblyUUID(){
        return assemblyUUID;
    }
    // ==================================================================
    //
    // Common component methods.
    //
    // ==================================================================
    public  void 
    configuration_complete()
    {        
        try{
            ((AssemblyInstanceManagementSegImpl)
             obtain_executor("assembly_instance_management"))
                .setupXML(xml_descriptor);        
        }
        catch(Exception e){
            e.printStackTrace();
        }                
    }
    /**
     * Implementation of the removing method.
     * A removinf event will be sent soon.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        if(!removed)
            {
                try{
                     removed=true;
                    ((AssemblyInstanceManagementSegImpl)
                     obtain_executor("assembly_instance_management"))
                        .uninstall();
                   
                }
                catch(Exception e){
                    e.printStackTrace();
                }
            }
    }

    public void
    push(AssemblyManagerRemoved amr)
    {

        try
            {
                //  System.err.println("AMMI >> Disconnect received");
                ((AssemblyInstanceManagementSegImpl)
                 obtain_executor("assembly_instance_management"))
                    .disconnectRemovedAssembly(amr.assembly_manager_ref);
            }
        catch(Exception e){
            e.printStackTrace();
        }
    }
}
