/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the OpenCCM_DCI::ContainerManager.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class ContainerManagerImpl
     extends org.objectweb.openccm.OpenCCM_DCI.
             ContainerManagerSessionComposition.ContainerManagerImpl
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    //container configuration
    private org.omg.Components.ConfigValue configuration[];
    //cookie identifiing parent node connection
    private org.omg.Components.Cookie cookie;
    //Registration interface reference
    private org.objectweb.openccm
        .OpenCCM_DCI.ContainerManagerRegistration ContMR;
    
    //temporary boolean to marks the ComponentsServer removall will be replace
    //by design pattern state
    private boolean removed;

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    /**
     * Configure complete the component.
     */
    public void 
    configuration_complete()
    {
        //retrieve the reference on the ContainerManagerRegistration interface
        ContMR=get_context().get_connection_container_manager_registration();
        
        try{
            org.omg.Components.SessionContext sc=
                (org.omg.Components.SessionContext)get_context();
            
            ((ContainerSegImpl)obtain_executor("container"))
                .configuration(configuration);
            //register the container
            cookie=ContMR
                .register_container_manager(
                                            org.objectweb.openccm.
                                            OpenCCM_DCI.ContainerManagerHelper
                                            .narrow(sc.get_CCM_object()));
            //setup the cookie
            ((ContainerSegImpl)obtain_executor("container")).cookie(cookie);
        }
        catch(Exception e)
            {
                e.printStackTrace();
            }
    }
    
    
    public
    void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        if(!removed){   
            removed=true;
            try
                {
                    //CSMR.unregister_component_server_manager(cookie);  
                    ((ContainerSegImpl)obtain_executor("container")).remove();
                }
            catch(Exception e )
                {
                    System.out.println("Cannot disconnect ComponentServer/Container");
                    e.printStackTrace();
                }
          
        }  
            
    }
     // ==================================================================
    //
    // Accessor methods.
    //
    // ==================================================================
    
    public 
    org.omg.Components.ConfigValue []
    config()
    {
        return configuration;
    }

    public 
    void 
    config(org.omg.Components.ConfigValue configuration[]){
        this.configuration=configuration;
    }
    
}
