/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;
/**
 * This is the implementation of the DCIInformation facet provided by the
 * DCIManager component.
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */
public class DCIInformationSegImpl  
    extends org.objectweb.openccm
            .OpenCCM_DCI.DCIManagerSessionComposition
            .DCIInformationSeg    
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private org.objectweb.openccm.OpenCCM_DCI.DCIManagerCCM DCI;
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    public void setupDCI(){
        DCI=(org.objectweb.openccm.OpenCCM_DCI.DCIManagerCCM)get_context(); 
    }


    /**
     * The 'get_node_manager' operation returns
     * a node manager associated to the given node name.
     *
     * @param node_node The node name to search.
     *
     * @return The NodeManager instance associated to the given node name.
     *
     * @throw ::Components::InvalidName
     *        Thrown when the node name is unknown,
     *        i.e. No NodeManager instance for this node name.
     *
     * WARNING: Must be merged with the NodeManagement::get_node operation.
     */
    public org.ist.coach.DCI.NodeManager
    get_node_manager(String node_name)
    throws org.omg.Components.InvalidName
    {
        org.objectweb.openccm.OpenCCM_DCI.
            DCIManagerPackage.node_managersConnection 
            connect[]=DCI.get_connections_node_managers();
        
        for(int i=0;i<connect.length;i++)
            if(connect[i].objref.node_name().equals(node_name))
                return connect[i].objref ;
        
        throw new org.omg.Components.InvalidName();            
    }

    /**
     * Obtain all the node managers.
     *
     * @return All the node managers.
     */
    public org.ist.coach.DCI.NodeManager[] 
    get_node_managers()
    {
        org.objectweb.openccm.OpenCCM_DCI.
            DCIManagerPackage.node_managersConnection 
            connect[]=DCI.get_connections_node_managers();
        
        org.ist.coach.DCI.NodeManager[] nodes=
            new  org.ist.coach.DCI.NodeManager[connect.length];
        
        for(int i=0;i<connect.length;i++)
            nodes[i]=connect[i].objref;
        
        return nodes;                         
    }


    /**
     * The 'get_dci_properties' operation returns
     * the DCI properties in a XML format.
     *
     * @return DCI properties in a XML format.
     *
     * WARNING: What parameters must be accepted by this operation?
     */
    public org.ist.coach.DCI.DCIDescriptor[]
        get_dci_properties(){
        return null;
    }

    /**
     * The 'get_node_properties' operation returns
     * the node properties in a XML format.
     *
     * @return Node properties in a XML format.
     *
     * WARNING: What parameters must be accepted by this operation?
     */
    public org.ist.coach.DCI.DCIDescriptor[]
        get_node_properties(String nodeName){
        return null;
    }
    

}
