/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

import org.objectweb.ccm.descriptor.softpkg.beans.SoftpkgBean;
import org.objectweb.ccm.descriptor.softpkg.beans.SoftpkgBeanImpl;

/**
 * This is the action class for opening a CSD from an assembly
 *
 */
public class ComponentfileEditActionListener
  implements org.objectweb.util.browser.api.ExtendedActionListener
{
    public void
    actionPerformed (org.objectweb.util.browser.api.ExtendedActionEvent the_event)
    {
        // retrieve the XML element from which comes the call
        org.objectweb.ccm.descriptor.componentassembly.beans.ComponentfileBean csd_file
         = (org.objectweb.ccm.descriptor.componentassembly.beans.ComponentfileBean)
           the_event.getTreeView().getValue();

        // gets the calling tree
        org.objectweb.util.browser.gui.core.DynamicTree calling_tree
         = (org.objectweb.util.browser.gui.core.DynamicTree)
           the_event.getTreeView().getTreeConfiguration();

        //gets the frame
        org.objectweb.apollon.gui.ApollonFrame calling_frame
         = (org.objectweb.apollon.gui.ApollonFrame)
            calling_tree.getRootPane().getParent();

        java.io.File softpkg
         = new java.io.File(csd_file.getFileinarchive().getName());

        // file is new
        if (!softpkg.exists())
        {
            SoftpkgBean softpkg_instance
             = new SoftpkgBeanImpl();

            softpkg_instance.setDocType("softpkg","","dtd/softpkg.dtd");

            try {
                softpkg_instance.marshalBean(
                    new java.io.File(csd_file.getFileinarchive().getName())
                    );
            } catch (Exception exception) {
                exception.printStackTrace();
            }
        }
        else
        {
            // file exists
        }

        calling_frame.open_file(
            new java.io.File(
                csd_file.getFileinarchive().getName()
                )
            );
    }
}
