/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

// Package dependencies
import org.objectweb.util.browser.api.ExtendedActionListener;
import org.objectweb.util.browser.api.ExtendedActionEvent;

/**
 * This is the action class for saving a file modified
 *
 */
public class SaveFile
  implements ExtendedActionListener
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The constructor taking an event as parameter
     */
    public void actionPerformed(ExtendedActionEvent e)
    {
        String action = e.getActionEvent().getActionCommand();

        // gets the calling instance
        org.objectweb.apollon.framework.Bean zeus_instance
            = (org.objectweb.apollon.framework.Bean)
                e.getTreeView().getValue();

        // gets the calling entry
        org.objectweb.util.browser.naming.api.Entry entry
         = e.getTreeView().getEntry();

        String descriptor_filename
         = entry.getOWName().getOWId();

        // marshals the descriptor to its file name
        java.io.File descfile
         = new java.io.File(
            descriptor_filename
            );

        if (!descfile.exists())
        {
            try
            {
                descfile.createNewFile();
            } catch (java.io.IOException except) {
                except.printStackTrace();
            }
        }
        try
        {
            zeus_instance.marshalBean(descfile);
        } catch (Exception except) {
            except.printStackTrace();
        }
    }
}
