/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

/**
 * This is a widget allowing to choose a code type
 *   for a component implementation
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class SoftpkgResourceType
     extends javax.swing.JPanel
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** the swing scroll list */
    private javax.swing.JComboBox scrolling_list;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public
    SoftpkgResourceType ()
    {
        // the possible values
        String[] values
         = {
            "DLL"
            ,"Executable"
            ,"Java Class"
            };

        // inits the scroll list
        scrolling_list = new javax.swing.JComboBox(values);

        this.setLayout(new java.awt.BorderLayout());

        javax.swing.JPanel content = new javax.swing.JPanel();
        content.setLayout(new java.awt.BorderLayout());
        content.add(this.scrolling_list, java.awt.BorderLayout.CENTER);

        // sets a default value in the list
        setResourceType("Java Class");
        scrolling_list.validate();

        // adding the content to the panel
        this.add(content, java.awt.BorderLayout.CENTER);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * The getter method
     */
    public String
    getResourceType()
    {
        return (String)this.scrolling_list.getSelectedItem();
    }

    /**
     * The setter method
     */
    public void
    setResourceType (String resource_type)
    {
        this.scrolling_list.setSelectedItem(resource_type);
    }
}
