/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.services.pss.jdo.lib;

/**
 *  This is a base class for Storage Objects implemented with JDO.
 */
public abstract class StorageObjectBase
              extends org.objectweb.openccm.services.pss.common.lib.StorageObjectBase
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public StorageObjectBase()
    {
        super();
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for org.omg.CosPersistentState.StorageObject
    //
    // ==================================================================

    /**
     * Destroy the associated Storage Object.
     */
    public void
    destroy_object()
    {
        org.objectweb.openccm.services.pss.jdo.api.CatalogBase catalog = null;
        javax.jdo.PersistenceManager pm = null;

        // Get the persistent manager
        catalog = (org.objectweb.openccm.services.pss.jdo.api.CatalogBase)
                        get_storage_home().get_catalog();
        pm = catalog.get_persistence_manager();

        // Remove the storage type
        catalog.begin_tx();
        pm.deletePersistent(this);
        catalog.commit_tx();
   }

    // ==================================================================
    //
    // Methods for org.objectweb.openccm.services.pss.common.api.StorageObject
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for org.objectweb.openccm.services.pss.jdo.api.StorageObject
    //
    // ==================================================================

    /**
     * Create the short PID.
     */
    public String
    create_short_pid()
    {
        return javax.jdo.JDOHelper.getObjectId(this).toString();
    }

}
