@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s):Briclet Frederic
rem # Contributor(s): ------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Start the OpenCCM Java AssemblyFactory.
rem #
rem # ====================================================================

setlocal

rem #  =====================
rem #  Compute Command Line
rem #  =====================



set /a nb_args=0
for %%i in (%*) do set /a nb_args=nb_args+1

if %nb_args% == 0 goto help
if %nb_args% == 1 goto setName


if "%1"=="-h" goto :help
if "%1"=="?" goto :help

goto :error

:setName
set factory_name=%1
goto start
	
goto :no_help

:help
echo "usage: factory_start  <factory_name>"	
goto :eof

:no_help

:start
set FACTORY_PATH=%OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%\factory_%factory_name%


rem #  ============================
rem #  OpenCCM Platform installed ?
rem #  ============================

:platform_installed
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

rem #  ======================
rem #  Name Service started ?
rem #  ======================

rem # Obtain the IOR of the started Name Service.
call ns_ior > %OpenCCM_CONFIG_DIR%\AssemblyFActoryManagers\%factory_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%.tmp) do set ior_NS=%%i
del %OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%.tmp

rem # Check if a Name Service is started.
if defined ior_NS goto test_trader

echo Error: The Name Service is not started!
goto :eof

:test_trader
set trader_arg= 
rem # ===========================================
rem # Obtain the IOR of the started Trading Service.
rem # ===========================================
if not exist %OpenCCM_CONFIG_DIR%\TradingService.IOR goto :launch
call trader_ior > %OpenCCM_CONFIG_DIR%\trader.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\trader.tmp) do set ior_Trader=%%i
del %OpenCCM_CONFIG_DIR%\trader.tmp

set trader_arg=-ORBInitRef TradingService=%ior_Trader%

:launch
:test_dci
rem #  ======================
rem #  DCI started ?
rem #  ======================

rem # Obtain the IOR of the started DCI.
call dci_ior > %OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%.tmp) do set ior_DCI=%%i
del %OpenCCM_CONFIG_DIR%\AssemblyFActoryManagers\%factory_name%.tmp

rem # Check if a Name Service is started.
if defined ior_DCI goto test_factory

echo Error: The DCI is not started!
goto :eof


:test_factory


rem #  =============
rem #  Factory started ?
rem #  =============

rem # Check if this Java AssemblyFactoryManager is already started.
if not exist %FACTORY_PATH%.PID goto :factory_not_started

echo Error: The Component AssemblyFactoryManager %factory_name% is already started!
goto :eof

:factory_not_started

mkdir %OpenCCM_CONFIG_DIR%\AssemblyFactoryManagers\%factory_name%\

set jvm_args="-Dior_ns=%ior_NS% -Dior_dci=%ior_DCI%"
set run_id=factory_start

:run

set args="%trader_arg% --runid %run_id% NSREGISTER=OpenCCM/AssemblyFactoryManagers/%factory_name% FACTORYNAME=%factory_name% IORPATH=%FACTORY_PATH%.IOR %OpenCCM_HOMEDIR%\xml\launcher\factory_server.xml"

call launcher fork %jvm_args% %args%  %FACTORY_PATH%.output %FACTORY_PATH%.PID

echo The AssemblyFactoryManager %factory_name% is started