@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Pierre Carpentier.
rem # Contributor(s): ____________________________________________.
rem #
rem # ====================================================================
rem #
rem # Starting the MOF Repository.
rem #
rem # ====================================================================

setlocal

call ccm_install
call ns_start

rem # Check if the MOF Repository IR3 is already started.
if not exist %OpenCCM_CONFIG_DIR%\MOFRepository.IOR goto not_started

echo Error: The MOF Repository is already started!
goto :eof

:not_started

echo The MOF Repository will be started.

rem # Check if the OpenCCM configuration directory doesn't exist.
if exist %OpenCCM_CONFIG_DIR% goto cfg_exist

echo Creating the %OpenCCM_CONFIG_DIR% directory.
mkdir %OpenCCM_CONFIG_DIR%

:cfg_exist

echo Launching the MOF Repository.

rem # Remove the MOFRepository.start file if present.
if exist %OpenCCM_CONFIG_DIR%\MOFRepository.start del %OpenCCM_CONFIG_DIR%\MOFRepository.start

set args="%OpenCCM_CONFIG_DIR%\MOFRepository.IOR %OpenCCM_HOMEDIR%/xml/launcher/MOFStart.xml "
call launcher fork "" %args% %OpenCCM_CONFIG_DIR%\MOFRepository.output %OpenCCM_CONFIG_DIR%\MOFRepository.PID

rem # Wait for availability of the MOF Repository.
:wait
set READY=
if not exist %OpenCCM_CONFIG_DIR%\MOFRepository.IOR goto :wait
copy %OpenCCM_CONFIG_DIR%\MOFRepository.IOR %OpenCCM_CONFIG_DIR%\MOFRepository.IOR.tmp >nul
for /f %%i in (%OpenCCM_CONFIG_DIR%\MOFRepository.IOR.tmp) do set READY=ok
if not defined READY goto :wait
del %OpenCCM_CONFIG_DIR%\MOFRepository.IOR.tmp

rem # Unblock the Ant compilation when waiting for
rem # the MOF Repository is started.
echo IR3_STARTED > %OpenCCM_CONFIG_DIR%\MOFRepository.start

echo The MOF Repository is started.


