@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2002 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                       Philippe Merle.
rem # Contributor(s): --------------------------------------------------.
rem #
rem # ====================================================================
rem #
rem #  Stopping the MOF Repository.
rem #
rem # ====================================================================

setlocal

rem Check if the MOF Repository is started.
if not exist %OpenCCM_CONFIG_DIR%\MOFRepository.start goto :eof

rem echo Please, close MOF Repository window.
rem pause

echo The MOF Repository will be stopped.

rem # Shutdown the MOF Repository process.
rem call %OpenCCM_HOMEDIR%\bin\shutdown file:%OpenCCM_CONFIG_DIR%\MOFRepository.IOR
kill F%OpenCCM_CONFIG_DIR%\MOFRepository.PID > nul

rem Remove the associated files.
del %OpenCCM_CONFIG_DIR%\MOFRepository.PID
del %OpenCCM_CONFIG_DIR%\MOFRepository.IOR
del %OpenCCM_CONFIG_DIR%\MOFRepository.output
del %OpenCCM_CONFIG_DIR%\MOFRepository.start
rem del %OpenCCM_CONFIG_DIR%\MOFRepository.output.tmp

rem Stopping the NameService
call ns_stop

rem Check if the OpenCCM Platform was not installed.
if exist %OpenCCM_CONFIG_DIR%\ComponentServers goto stopped

rem Remove the OpenCCM configuration directory.
echo Removing the %OpenCCM_CONFIG_DIR% directory.
rmdir /s /q %OpenCCM_CONFIG_DIR%

:stopped
echo The MOF Repository is stopped.
