/*====================================================================

ObjectWeb Util Launcher Package.
Copyright (C) 2003 INRIA & USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): .

====================================================================*/

package org.objectweb.util.launcher.cmdline ;


import org.objectweb.util.cmdline.lib.DefaultCommandLine;

import org.objectweb.util.launcher.parser.Parser;


/**
 * LauncherCmdline specialization of DefaultCommandLine object<BR>
 * <p>
 * this structure considers only characters list
 * </p>
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 *
 * @version 0.1
 */
public class LauncherCmdline
    extends DefaultCommandLine
{

    protected Parser parser_ ;

    public LauncherCmdline(Parser parser) {
        super("java org.objectweb.util.launcher.Launcher",
              "file:<my_application.xml>",
              new String[] {"Launch a new application", 
                            "The application to launch is described in the <my_application.xml> file"},
              true);
        setParser(parser);
        super.addOption(new OptionVerbose());
        super.addOption(new OptionDebug());
        super.addOption(new OptionProperty());
        super.addOption(new OptionArg());
        super.addOption(new OptionOption(getParser()));

        super.addOption(new OptionRun(getParser()));
        super.addOption(new OptionLoad(getParser()));
    }

    public void setParser(Parser parser) { this.parser_ = parser; }
    public Parser getParser() { return this.parser_; }
}
