/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl;

import fr.lip6.src.modfact.util.Helper;
import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class GenerationMOFIDL1_3 {
	//Helper
	Helper helper = new Helper();

	//les proprits
	private java.io.PrintWriter _out;

	Logger logger =
		LogManager.getLogManager().getLogger(
			"fr.lip6.src.mdafactory.generation.idl.GenerationMOFIDL1_3");

	public void setOut(String _file) throws java.io.FileNotFoundException {
		logger.log(Level.CONFIG, "IDL output set to" + _file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
		logger.log(Level.CONFIG, "IDL output set to" + _file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public void setOut(OutputStream stream) {
		logger.log(Level.CONFIG, "IDL output set to a stream");
		_out = new java.io.PrintWriter(stream);
	}

	public void closeFile() {
		logger.log(Level.FINE, "");
		_out.close();
	}

	// gnration d'IDL
	public void generateIDL(org.omg.mof.Model.Package _Package)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		logger.log(Level.FINE, "IDL beginning of the generation");
		_out.println("#include <Reflective.idl>");
		packageModuleTemplate(_Package);
		closeFile();
	}

	public void packageModuleTemplate(org.omg.mof.Model.Package _package)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		logger.log(Level.FINE, "IDL packageModuleTemplate");
		if (_package
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {

			org.omg.mof.Model.ModelElement[] _contents = _package.contents();
			java.util.Vector _datatypes = new java.util.Vector();
			java.util.Vector _packages = new java.util.Vector();
			java.util.Vector _classes = new java.util.Vector();
			java.util.Vector _associations = new java.util.Vector();
			java.util.Vector _exceptions = new java.util.Vector();
			java.util.Vector _constraints = new java.util.Vector();
			java.util.Vector _constants = new java.util.Vector();
			java.util.Vector _tags = new java.util.Vector();
			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id()))
					_classes.addElement(
						org.omg.mof.Model.ClassHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.PackageHelper.id()))
					_packages.addElement(
						org.omg.mof.Model.PackageHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.DataTypeHelper.id()))
					_datatypes.addElement(
						org.omg.mof.Model.DataTypeHelper.narrow(_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.MofExceptionHelper.id()))
					_exceptions.addElement(
						org.omg.mof.Model.MofExceptionHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.AssociationHelper.id()))
					_associations.addElement(
						org.omg.mof.Model.AssociationHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(
						org.omg.mof.Model.ConstraintHelper.id()))
					_constraints.addElement(
						org.omg.mof.Model.ConstraintHelper.narrow(
							_contents[i]));
				else if (
					_contents[i]._is_a(org.omg.mof.Model.ConstantHelper.id()))
					_constants.addElement(
						org.omg.mof.Model.ConstantHelper.narrow(_contents[i]));
				else if (_contents[i]._is_a(org.omg.mof.Model.TagHelper.id()))
					_tags.addElement(
						org.omg.mof.Model.TagHelper.narrow(_contents[i]));
			}

			java.util.Vector _classes_ordered = new java.util.Vector();
			while (_classes.size() != 0) {
				org.omg.mof.Model.Class _courant = null;
				for (int i = 0; i < _classes.size(); i++) {
					_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes =
						_courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (Helper.contains(_classes, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_classes_ordered.addElement(_courant);
						_classes.removeElement(_courant);
					}
				}
			}

			// rcuprer le contenu des classes pour minimiser les appels CORBA au cours du traitements du contenu de ces classeses
			for (int i = 0; i < _classes_ordered.size(); i++)
				helper.allContentsOfClasses(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i));

			//Apples des diffre,ts Teplates correspendants
			for (int i = 0; i < _tags.size(); i++)
				tagTemplate((org.omg.mof.Model.Tag) _tags.elementAt(i));

			//ecriture des annotations
			annotationTemplate(_package.annotation());
			String _packageName1 = Helper.format1(_package.name());
			_out.println("module " + _package.name() + " {");
			_out.println("interface " + _packageName1 + "Package ;");

			for (int i = 0; i < _constants.size(); i++)
				constantTemplate(
					(org.omg.mof.Model.Constant) _constants.elementAt(i));

			for (int i = 0; i < _classes_ordered.size(); i++)
				classForwardDeclarationTemplate(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i));

			for (int i = 0; i < _packages.size(); i++)
				packageModuleTemplate(
					(org.omg.mof.Model.Package) _packages.elementAt(i));

			for (int i = 0; i < _datatypes.size(); i++)
				dataTypeTemplate(
					(org.omg.mof.Model.DataType) _datatypes.elementAt(i));

			for (int i = 0; i < _exceptions.size(); i++)
				exceptionTemplate(
					(org.omg.mof.Model.MofException) _exceptions.elementAt(i));

			for (int i = 0; i < _classes_ordered.size(); i++)
				classTemplate(
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i));

			for (int i = 0; i < _associations.size(); i++)
				associationTemplate(
					(org.omg.mof.Model.Association) _associations.elementAt(i));

			for (int i = 0; i < _constraints.size(); i++)
				constraintTemplate(
					(org.omg.mof.Model.Constraint) _constraints.elementAt(i));

			//Generate the Package Factory interface
			packageFactoryTemplate(_package);

			// Generate the Package interface
			packageTemplate(_package);
			_out.println("}; //end of module " + _packageName1);
			_out.println("");
		} else {
		} //do_nothing
	}

	//tag
	public void tagTemplate(org.omg.mof.Model.Tag tag)
		throws org.omg.mof.Reflective.MofError {
		if (tag.tag_id().compareTo("org.omg.mof.idl_prefix") == 0)
			_out.println(
				"#pragma prefix \"" + tag.values()[0].extract_string() + "\"");
	}

	//annotation
	public void annotationTemplate(String _annotation)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL annotationTemplate");
		_out.println("\t//" + _annotation);
	}

	public void classForwardDeclarationTemplate(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL classForwardDeclarationTemplate");
		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			String _classname = helper.format1(_class.name());
			_out.println("interface " + _classname + "Class;");
			_out.println("interface " + _classname + ";");
			_out.println(
				"typedef sequence <" + _classname + "> " + _classname + "Set;");
			_out.println(
				"typedef sequence <" + _classname + "> " + _classname + "Bag;");
			_out.println(
				"typedef sequence <"
					+ _classname
					+ "> "
					+ _classname
					+ "List;");
			_out.println(
				"typedef sequence <"
					+ _classname
					+ "> "
					+ _classname
					+ "UList;");
		} else {
		}; //rien  faire
	}

	public void dataTypeTemplate(org.omg.mof.Model.DataType _datatype)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		logger.log(Level.FINE, "IDL dataTypeTemplate");
		if (_datatype
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			annotationTemplate(_datatype.annotation());
			String _datatypename = _datatype.name();

			if (_datatypename.startsWith("*")) {
				_datatypename = _datatypename.substring(1);
				String _idlbasename = idlBaseType(_datatypename);
				_out.println(
					"typedef sequence <"
						+ _datatypename
						+ "> "
						+ _idlbasename
						+ "Set;");
				_out.println(
					"typedef sequence <"
						+ _datatypename
						+ "> "
						+ _idlbasename
						+ "Bag;");
				_out.println(
					"typedef sequence <"
						+ _datatypename
						+ "> "
						+ _idlbasename
						+ "List;");
				_out.println(
					"typedef sequence <"
						+ _datatypename
						+ "> "
						+ _idlbasename
						+ "UList;");

			} else {
				String _datatypename1 = helper.format1(_datatype.name());
				org.omg.CORBA.TypeCode _typecode = _datatype.type_code();
				typeCode2IDL(_typecode, 0, _datatypename);
				for (int i = 0; i < _datatype.constraints().length; i++) {
					constraintTemplate(_datatype.constraints()[i]);
				}
				_out.println(
					"typedef sequence <"
						+ _datatypename1
						+ "> "
						+ _datatypename1
						+ "Set;");
				_out.println(
					"typedef sequence <"
						+ _datatypename1
						+ "> "
						+ _datatypename1
						+ "Bag;");
				_out.println(
					"typedef sequence <"
						+ _datatypename1
						+ "> "
						+ _datatypename1
						+ "List;");
				_out.println(
					"typedef sequence <"
						+ _datatypename1
						+ "> "
						+ _datatypename1
						+ "UList;");

			}
		}
	}

	public void typeCode2IDL(
		org.omg.CORBA.TypeCode _typecode,
		int _level,
		String _datatypename)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		logger.log(Level.FINE, "IDL typeCode2IDL");
		switch (_typecode.kind().value()) {
			case org.omg.CORBA.TCKind._tk_alias :
				{
					org.omg.CORBA.TypeCode _tc = _typecode.content_type();
					_out.print("typedef ");
					typeCode2IDL(_tc, 0, _tc.name());
					//_out.println(" " + _tc.name() + " ;");
					_out.println(" " + helper.format1(_datatypename) + " ;");
					break;
				}
			case org.omg.CORBA.TCKind._tk_struct :
				{
					//_out.print("struct " + helper.format1(_typecode.name()) + "{");
					_out.print("struct " + helper.format1(_datatypename) + "{");
					int _temp = _level + 1;
					for (int i = 0; i < _typecode.member_count(); i++) {
						typeCode2IDL(
							_typecode.member_type(i),
							_temp,
							_typecode.member_name(i));
						//_out.print(" " + _typecode.member_name(i) + "; ");
						_out.print(" " + _typecode.member_name(i) + "; ");
					}
					_out.print("} ");
					if (_level == 0)
						_out.println(";");
					break;
				}
			case org.omg.CORBA.TCKind._tk_enum :
				{
					//_out.print("enum " + helper.format1(_typecode.name()) + "{");
					_out.print("enum " + helper.format1(_datatypename) + "{");
					for (int i = 0; i < _typecode.member_count(); i++) {
						_out.print(_typecode.member_name(i));
						if (!(i == (_typecode.member_count() - 1)))
							_out.print(", ");
					}
					_out.print("} ");
					if (_level == 0)
						_out.println(";");
					break;
				}
			case org.omg.CORBA.TCKind._tk_sequence :
				{
					org.omg.CORBA.TypeCode _tc = _typecode.content_type();
					_out.print("typedef sequence<");
					int _temp = _level + 1;
					typeCode2IDL(_tc, _temp, "");
					if (_typecode.length() > 1)
						_out.print(
							" ," + String.valueOf(_typecode.length()) + ">");
					if (_level == 0)
						_out.println(helper.format1(_datatypename) + ";");
					break;
				}
			default :
				typeCode2IDLBase(_typecode);
		}
	}

	public void typeCode2IDLBase(org.omg.CORBA.TypeCode _typecode)
		throws org.omg.CORBA.TypeCodePackage.BadKind {
		logger.log(Level.FINE, "IDL typeCode2IDLBase");
		switch (_typecode.kind().value()) {
			case org.omg.CORBA.TCKind._tk_boolean :
				{
					_out.print("boolean");
					break;
				}
			case org.omg.CORBA.TCKind._tk_octet :
				{
					_out.print("octet");
					break;
				}
			case org.omg.CORBA.TCKind._tk_char :
				{
					_out.print("char");
					break;
				}
			case org.omg.CORBA.TCKind._tk_wchar :
				{
					_out.print("wchar");
					break;
				}
			case org.omg.CORBA.TCKind._tk_short :
				{
					_out.print("short");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ushort :
				{
					_out.print("unsigned short");
					break;
				}
			case org.omg.CORBA.TCKind._tk_long :
				{
					_out.print("long");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ulong :
				{
					_out.print("unsigned long");
					break;
				}
			case org.omg.CORBA.TCKind._tk_longlong :
				{
					_out.print("long long");
					break;
				}
			case org.omg.CORBA.TCKind._tk_ulonglong :
				{
					_out.print("unsigned long long");
					break;
				}
			case org.omg.CORBA.TCKind._tk_double :
				{
					_out.print("double");
					break;
				}
			case org.omg.CORBA.TCKind._tk_float :
				{
					_out.print("float");
					break;
				}
			case org.omg.CORBA.TCKind._tk_string :
				{
					_out.print("string");
					break;
				}
			case org.omg.CORBA.TCKind._tk_wstring :
				{
					_out.print("wstring");
					break;
				}
			case org.omg.CORBA.TCKind._tk_TypeCode :
				{
					_out.print("CORBA::TypeCode");
					break;
				}
			case org.omg.CORBA.TCKind._tk_any :
				{
					_out.print("any");
					break;
				}
			case org.omg.CORBA.TCKind._tk_objref :
				{
					_out.print("Object");
					break;
				}
			default :
				throw new org.omg.CORBA.TypeCodePackage.BadKind();
		}
	}

	//les types IDL de base

	public String idlBaseType(String _in) {
		logger.log(Level.FINE, "IDL idlBaseType");
		if (_in.compareToIgnoreCase("boolean") == 0)
			return "Boolean";
		else if (_in.compareToIgnoreCase("octet") == 0)
			return "Octet";
		else if (_in.compareToIgnoreCase("char") == 0)
			return "Char";
		else if (_in.compareToIgnoreCase("wchar") == 0)
			return "WChar";
		else if (_in.compareToIgnoreCase("short") == 0)
			return "Short";
		else if (_in.compareToIgnoreCase("unsigned short") == 0)
			return "UShort";
		else if (_in.compareToIgnoreCase("long") == 0)
			return "Long";
		else if (_in.compareToIgnoreCase("unsigned long") == 0)
			return "ULong";
		else if (_in.compareToIgnoreCase("long long") == 0)
			return "LLong";
		else if (_in.compareToIgnoreCase("unsigned long long") == 0)
			return "ULLong";
		else if (_in.compareToIgnoreCase("double") == 0)
			return "Double";
		else if (_in.compareToIgnoreCase("float") == 0)
			return "Float";
		else if (_in.compareToIgnoreCase("string") == 0)
			return "String";
		else if (_in.compareToIgnoreCase("wstring") == 0)
			return "WString";
		else if (_in.compareToIgnoreCase("any") == 0)
			return "Any";
		else if (_in.compareToIgnoreCase("CORBA::TypeCode") == 0)
			return "TypeCode";
		else if (_in.compareToIgnoreCase("Object") == 0)
			return "Object";
		else
			return _in;
	}

	public String idlType(org.omg.mof.Model.Classifier _classifier)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL idlType");
		String _resu = _classifier.name();
		if (_resu.startsWith("*")) {
			_resu = _resu.substring(1);
			//fin("IDLTypeTemplate", _classifier.name());
			return _resu;
		} else {
			_resu = qualifiedName(_classifier);
			return _resu;
		}

	}

	public String qualifiedName(org.omg.mof.Model.ModelElement _modelelement)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL qualifiedName");
		boolean bool = false;
		String _namespacestring = "::" + helper.format1(_modelelement.name());
		try {
			org.omg.mof.Model.Namespace current = _modelelement.container();
			while (!bool) {
				if (current._is_a(org.omg.mof.Model.ClassHelper.id())) {
					_namespacestring =
						"::"
							+ helper.format1(current.name())
							+ "Class"
							+ _namespacestring;
					current = current.container();
				} else {
					//_namespacestring = "::"+helper.format1(current.name())+_namespacestring ;
					_namespacestring = _namespacestring.substring(2);
					bool = true;
				}
			}
		} catch (org.omg.mof.Reflective.NotSet ex) {
		}
		return _namespacestring;
	}

	public void exceptionTemplate(org.omg.mof.Model.MofException _exception)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL exceptionTemplate");
		if (_exception
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			String _exceptionname = helper.format1(_exception.name());
			annotationTemplate(_exception.annotation());
			_out.println("\texception " + _exceptionname + " {");
			for (int i = 0; i < _exception.contents().length; i++) {
				org.omg.mof.Model.Parameter _parameter =
					org.omg.mof.Model.ParameterHelper.narrow(
						_exception.contents()[i]);
				_out.print("\t" + idlBaseType(idlType(_parameter.type())));
				if ((_parameter.multiplicity().upper > 1)
					|| (_parameter.multiplicity().upper == -1)) {
					if (_parameter.multiplicity().isOrdered) {
						if (_parameter.multiplicity().isUnique) {
							_out.print("UList");
						} else {
							_out.print("List");
						}
					} else {
						if (_parameter.multiplicity().isUnique) {
							_out.print("Set");
						} else {
							_out.print("Bag");
						}
					}
				}
				_out.print("   " + helper.format1(_parameter.name()) + " ;");
				_out.println("\t} ;");
			}
		}
	}

	//les classes
	public void classTemplate(org.omg.mof.Model.Class _class)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {

		logger.log(Level.FINE, "IDL classTemplate");
		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			annotationTemplate(_class.annotation());
			classProxyTemplate(_class);
			instanceTemplate(_class);
		}
	}
	public void associationTemplate(org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL associationTemplate");
		if (_association
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			String _associationformat1 = helper.format1(_association.name());
			String _associationformat2 = helper.format2(_association.name());
			org.omg.mof.Model.AssociationEnd[] _ends =
				associationEnds(_association);

			//proprit de la premire associationEnd
			org.omg.mof.Model.AssociationEnd _source = _ends[0];
			String _sourceformat1 = idlType(_source.type());
			String _sourceformat2 = helper.format2(_source.name());
			org.omg.mof.Model.MultiplicityType _multiplicity_source =
				_source.multiplicity();
			int _upper_source = _multiplicity_source.upper;
			int _lower_source = _multiplicity_source.lower;
			boolean _is_ordered_source = _multiplicity_source.isOrdered;
			boolean _is_unique_source = _multiplicity_source.isUnique;
			boolean _is_changeable_source = _source.is_changeable();
			boolean _is_navigable_source = _source.is_navigable();

			//proprit de la deuxime associationEnd
			org.omg.mof.Model.AssociationEnd _dest = _ends[1];
			String _destformat1 = idlType(_dest.type());
			String _destformat2 = helper.format2(_dest.name());
			org.omg.mof.Model.MultiplicityType _multiplicity_dest =
				_dest.multiplicity();
			int _upper_dest = _multiplicity_dest.upper;
			int _lower_dest = _multiplicity_dest.lower;
			boolean _is_ordered_dest = _multiplicity_dest.isOrdered;
			boolean _is_unique_dest = _multiplicity_dest.isUnique;
			boolean _is_changeable_dest = _dest.is_changeable();
			boolean _is_navigable_dest = _dest.is_navigable();

			//le code correspondant
			_out.println("struct " + _associationformat1 + "Link {");
			_out.println("\t" + _sourceformat1 + "  " + _sourceformat2 + "; ");
			_out.println("\t" + _destformat1 + "  " + _destformat2 + "; ");
			_out.println("\t};");

			_out.println(
				"typedef sequence  "
					+ "<"
					+ _associationformat1
					+ "Link> "
					+ _associationformat1
					+ "LinkSet;");

			annotationTemplate(_association.annotation());
			_out.println(
				"interface "
					+ _associationformat1
					+ ":Reflective::RefAssociation {");
			_out.println(
				"\t"
					+ _associationformat1
					+ "LinkSet all_"
					+ _associationformat2
					+ "_Links () raises (Reflective::MofError) ;");
			_out.print("\tboolean exists (");
			_out.print("in " + _sourceformat1 + "  " + _sourceformat2 + ", ");
			_out.print("in " + _destformat1 + "  " + _destformat2 + ")");
			_out.println("raises (Reflective::MofError);");

			if (_is_navigable_source) {
				if ((_upper_source > 1) || (_upper_source == -1)) {
					//une  ligne rajoute
					_out.print("\t" + idlBaseType(_sourceformat1));
					if ((_is_unique_source) && (_is_ordered_source)) {
						_out.print("UList  ");
					} else {
						if (_is_ordered_source) {
							_out.print("List  ");
						} else {
							if (_is_unique_source) {
								_out.print("Set  ");
							} else
								_out.print("Bag  ");
						}
					}
				} else {
					_out.print("\t" + _sourceformat1 + "  ");
				}
				_out.println(
					_sourceformat2
						+ "(in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ") raises (Reflective::MofError);");
			}
			if (_is_navigable_dest) {
				if ((_upper_dest > 1) || (_upper_dest == -1)) {
					//une  ligne rajoute
					_out.print("\t" + idlBaseType(_destformat1));
					if ((_is_unique_dest) && (_is_ordered_dest)) {
						_out.print("UList  ");
					} else {
						if (_is_ordered_dest) {
							_out.print("List  ");
						} else {
							if (_is_unique_dest) {
								_out.print("Set  ");
							} else
								_out.print("Bag  ");
						}
					}
				} else {
					_out.print("\t" + _destformat1 + "  ");
				}
				_out.println(
					_destformat2
						+ "(in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ") raises (Reflective::MofError);");
			}

			if (_is_changeable_source && _is_changeable_dest) {
				_out.println(
					"\tvoid add ( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ") raises (Reflective::MofError);");
			}
			if (_is_changeable_source
				&& _is_navigable_source
				&& _is_changeable_dest
				&& ((_upper_source > 1) || (_upper_source == -1))
				&& _is_ordered_source) {
				_out.println(
					"\tvoid add_before_"
						+ _sourceformat2
						+ "( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ", in "
						+ _sourceformat1
						+ " before) raises (Reflective::NotFound, Reflective::MofError);");
			}
			if (_is_changeable_dest
				&& _is_navigable_dest
				&& _is_changeable_source
				&& ((_upper_dest > 1) || (_upper_dest == -1))
				&& _is_ordered_dest) {
				_out.println(
					"\tvoid add_before_"
						+ _destformat2
						+ "( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ", in "
						+ _destformat1
						+ " before) raises (Reflective::NotFound, Reflective::MofError);");
			}
			if (_is_navigable_source && _is_changeable_source) {
				_out.println(
					"\tvoid modify_"
						+ _sourceformat2
						+ " ( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ", in "
						+ _sourceformat1
						+ " new_"
						+ _sourceformat2
						+ ") raises (Reflective::NotFound, Reflective::MofError);");
			}
			if (_is_navigable_dest && _is_changeable_dest) {
				_out.println(
					"\tvoid modify_"
						+ _destformat2
						+ " ( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ", in "
						+ _destformat1
						+ " new_"
						+ _destformat2
						+ ") raises (Reflective::NotFound, Reflective::MofError);");
			}
			if (_is_changeable_source && _is_changeable_dest) {
				_out.println(
					"\tvoid remove ( in "
						+ _sourceformat1
						+ "  "
						+ _sourceformat2
						+ ", in "
						+ _destformat1
						+ "  "
						+ _destformat2
						+ ") raises (Reflective::NotFound, Reflective::MofError);");
			}
			_out.println("\t}; // end of interface " + _associationformat1);
		}
		_out.println();
	}

	public org.omg.mof.Model.AssociationEnd[] associationEnds(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL associationEnds");
		org.omg.mof.Model.AssociationEnd[] _ass =
			new org.omg.mof.Model.AssociationEnd[2];
		org.omg.mof.Model.ModelElement[] _cont = _association.contents();
		for (int i = 0; i < _cont.length; i++) {
			if (_cont[i]._is_a(org.omg.mof.Model.AssociationEndHelper.id()))
				_ass[i] =
					(org.omg.mof.Model.AssociationEndHelper.narrow(_cont[i]));
		}
		return _ass;

	}

	public void constraintTemplate(org.omg.mof.Model.Constraint _constraint)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL constraintTemplate");
		annotationTemplate(_constraint.annotation());
		_out.println("\tconst string " + helper.format3(_constraint.name()));
	}

	//la Constante
	public void constantTemplate(org.omg.mof.Model.Constant _constant)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		annotationTemplate(_constant.annotation());
		org.omg.CORBA.Any _value = _constant.value();
		int _tk = _value.type().kind().value();
		_out.print(
			"const "
				+ idlType(_constant.type())
				+ " "
				+ helper.format3(_constant.name())
				+ " = ");
		if ((_tk == org.omg.CORBA.TCKind._tk_char)
			|| (_tk == org.omg.CORBA.TCKind._tk_wchar)
			|| (_tk == org.omg.CORBA.TCKind._tk_string)
			|| (_tk == org.omg.CORBA.TCKind._tk_wstring)) {
			_out.print("\"" + helper.constantValue(_value) + "\"");
		} else
			_out.print(helper.constantValue(_value));
		_out.println(" ;");
	}

	public void packageFactoryTemplate(org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		logger.log(Level.FINE, "IDL packageFactoryTemplate");
		if (_package.all_supertypes().length == 0) {
			String _packageformat1 = helper.format1(_package.name());
			String _packageformat2 = helper.format2(_package.name());
			org.omg.mof.Model.ModelElement[] _contents = _package.contents();
			java.util.Vector _classes = new java.util.Vector();

			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id()))
					_classes.addElement(
						org.omg.mof.Model.ClassHelper.narrow(_contents[i]));
			}
			java.util.Vector _classes_ordered = new java.util.Vector();
			while (_classes.size() != 0) {
				org.omg.mof.Model.Class _courant = null;
				for (int i = 0; i < _classes.size(); i++) {
					_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes =
						_courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (helper.contains(_classes, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_classes_ordered.addElement(_courant);
						_classes.removeElement(_courant);
					}
				}
			}
			java.util.Vector _attributes = new java.util.Vector();
			for (int j = 0; j < _classes_ordered.size(); j++) {
				java.util.Vector _attributes_temp =
					helper.attributsForClass(
						(org.omg.mof.Model.Class) _classes_ordered.elementAt(j),
						org.omg.mof.Model.ScopeKind.classifier_level,
						true);
				for (int i = 0; i < _attributes_temp.size(); i++) {
					org.omg.mof.Model.MofAttribute _current =
						(
							org
								.omg
								.mof
								.Model
								.MofAttribute) _attributes_temp
								.elementAt(
							i);
					_attributes.addElement(_current);
				}
			}
			_out.println("interface " + _packageformat1 + "PackageFactory {");
			_out.print(
				"\t"
					+ _packageformat1
					+ "Package  create_"
					+ _packageformat2
					+ "_package(");

			//calculer les attributs satatiques des classes dans le mtamodles
			for (int i = 0; i < _attributes.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i);
				String _currentformat1 = idlType(_current.type());
				String _attributeqname = " ";
				String[] _qualified_name = _current.qualified_name();
				for (int j = 0; j < _qualified_name.length; j++) {
					if (j > 0)
						_attributeqname =
							helper.format2(_qualified_name[j])
								+ "_"
								+ _attributeqname;
					else
						_attributeqname = helper.format2(_qualified_name[j]);
				}

				if (!((i != 0) || (i != (_attributes.size() - 1))))
					_out.println(", ");

				if ((_current.multiplicity().upper > 1)
					|| (_current.multiplicity().upper == -1)) {

					_out.print(idlBaseType(_currentformat1));
					if ((_current.multiplicity().isUnique)
						&& (_current.multiplicity().isOrdered)) {
						_out.print("UList  " + _attributeqname);
					} else {
						if (_current.multiplicity().isOrdered) {
							_out.print("List  " + _attributeqname);
						} else {
							if (_current.multiplicity().isUnique) {
								_out.print("Set  " + _attributeqname);
							} else
								_out.print("Bag  " + _attributeqname);
						}
					}
				} else {
					_out.print(_currentformat1 + "  " + _attributeqname);
				}
			}
			_out.println(") raises (Reflective::MofError);");
			_out.println("\t}; ");
		}
	}

	public void packageTemplate(org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL packageTemplate");
		String _pformat1 = helper.format1(_package.name());
		String _pformat2 = helper.format2(_package.name());
		_out.print("interface  " + _pformat1 + "Package :");

		if (_package.all_supertypes().length == 0)
			_out.println("Reflective::RefPackage {");
		else {
			org.omg.mof.Model.ModelElement[] _temp1 = _package.all_supertypes();
			java.util.Vector _packages = new java.util.Vector();
			for (int i = 0; i < _temp1.length; i++)
				_packages.addElement(_temp1[i]);
			java.util.Vector _packages_ordered = new java.util.Vector();
			while (_packages.size() != 0) {
				org.omg.mof.Model.Package _courant = null;
				for (int i = 0; i < _packages.size(); i++) {
					_courant =
						(org.omg.mof.Model.Package) _packages.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes =
						_courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (helper.contains(_packages, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_packages_ordered.addElement(_courant);
						_packages.removeElement(_courant);
					}
				}
			}
			for (int i = 0; i < _packages_ordered.size(); i++) {
				org.omg.mof.Model.Package _temp2 =
					(org.omg.mof.Model.Package) _packages_ordered.elementAt(i);
				if (_temp2
					.visibility()
					.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
					_out.print(helper.format1(_temp2.name()) + "Package ");
					if ((i != (_packages_ordered.size() - 1)))
						_out.print(", ");
				}
			}
			_out.println("{ ");
		}
		org.omg.mof.Model.ModelElement[] _contents = _package.contents();
		for (int i = 0; i < _contents.length; i++) {
			if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id())) {
				org.omg.mof.Model.Class _class =
					org.omg.mof.Model.ClassHelper.narrow(_contents[i]);
				if (_class
					.visibility()
					.equals(org.omg.mof.Model.VisibilityKind.public_vis))
					_out.println(
						"\treadonly attribute "
							+ helper.format1(_class.name())
							+ "Class  "
							+ helper.format2(_class.name())
							+ "_ref;");
			} else {
				if (_contents[i]
					._is_a(org.omg.mof.Model.AssociationHelper.id())) {
					org.omg.mof.Model.Association _association =
						org.omg.mof.Model.AssociationHelper.narrow(
							_contents[i]);
					if (_association
						.visibility()
						.equals(org.omg.mof.Model.VisibilityKind.public_vis))
						_out.println(
							"\treadonly attribute "
								+ helper.format1(_association.name())
								+ "  "
								+ helper.format2(_association.name())
								+ "_ref;");
				} else {
					if (_contents[i]
						._is_a(org.omg.mof.Model.PackageHelper.id())) {
						org.omg.mof.Model.Package _package_nested =
							org.omg.mof.Model.PackageHelper.narrow(
								_contents[i]);
						_out.println(
							"\treadonly attribute "
								+ helper.format1(_package_nested.name())
								+ "Package  "
								+ helper.format2(_package_nested.name())
								+ "_ref;");
					} else {
						if (_contents[i]
							._is_a(org.omg.mof.Model.ImportHelper.id())) {
							org.omg.mof.Model.Import _import =
								org.omg.mof.Model.ImportHelper.narrow(
									_contents[i]);
							if ((_import
								.visibility()
								.equals(
									org
										.omg
										.mof
										.Model
										.VisibilityKind
										.public_vis))
								&& (_import.is_clustered())
								&& (_import
									.visibility()
									.equals(
										org
											.omg
											.mof
											.Model
											.VisibilityKind
											.public_vis)))
								_out.println(
									"\treadonly attribute "
										+ helper.format1(_import.name())
										+ "Package  "
										+ helper.format2(_import.name())
										+ "_ref;");
						}
					}
				}
			}
		}

		_out.println("\t};");
	}
	public void classProxyTemplate(org.omg.mof.Model.Class _class)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.Bounds,
			org.omg.CORBA.TypeCodePackage.BadKind {

		logger.log(Level.FINE, "IDL classProxyTemplate");
		String _cformat1 = helper.format1(_class.name());
		String _cformat2 = helper.format2(_class.name());
		_out.println();
		_out.print("interface  " + _cformat1 + "Class :");
		org.omg.mof.Model.ModelElement[] _supertypes = _class.all_supertypes();
		if (_supertypes.length == 0)
			_out.print("Reflective::RefObject");
		else {
			for (int i = 0; i < _supertypes.length; i++) {
				org.omg.mof.Model.Class _temp =
					org.omg.mof.Model.ClassHelper.narrow(_supertypes[i]);
				_out.print(helper.format1(_temp.name()) + "Class ");
				if (i != (_supertypes.length - 1))
					_out.print(", ");
			}
		}
		_out.println("{ ");
		_out.println(
			"\treadonly attribute "
				+ _cformat1
				+ "Set all_of_type_"
				+ _cformat2
				+ " ;");
		if (!_class.is_abstract()) {
			_out.println(
				"\treadonly attribute "
					+ _cformat1
					+ "Set all_of_class_"
					+ _cformat2
					+ " ;");
		}
		org.omg.mof.Model.ModelElement[] _contents = _class.contents();
		java.util.Vector _constants = new java.util.Vector();
		java.util.Vector _datatypes = new java.util.Vector();
		java.util.Vector _exceptions = new java.util.Vector();
		java.util.Vector _constraints = new java.util.Vector();

		java.util.Vector _attributes_cl =
			helper.attributsForClass(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level,
				false);
		java.util.Vector _operations_cl =
			helper.operationsForClass(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level);

		for (int i = 0; i < _contents.length; i++) {
			if (_contents[i]._is_a(org.omg.mof.Model.ConstantHelper.id()))
				_constants.addElement(
					org.omg.mof.Model.ConstantHelper.narrow(_contents[i]));
			else if (_contents[i]._is_a(org.omg.mof.Model.DataTypeHelper.id()))
				_datatypes.addElement(
					org.omg.mof.Model.DataTypeHelper.narrow(_contents[i]));
			else if (
				_contents[i]._is_a(org.omg.mof.Model.MofExceptionHelper.id()))
				_exceptions.addElement(
					org.omg.mof.Model.MofExceptionHelper.narrow(_contents[i]));
			else if (
				_contents[i]._is_a(org.omg.mof.Model.ConstraintHelper.id()))
				_constraints.addElement(
					org.omg.mof.Model.ConstraintHelper.narrow(_contents[i]));
		}
		for (int i = 0; i < _constants.size(); i++)
			constantTemplate(
				(org.omg.mof.Model.Constant) _constants.elementAt(i));

		for (int i = 0; i < _datatypes.size(); i++)
			dataTypeTemplate(
				(org.omg.mof.Model.DataType) _datatypes.elementAt(i));

		for (int i = 0; i < _exceptions.size(); i++)
			exceptionTemplate(
				(org.omg.mof.Model.MofException) _exceptions.elementAt(i));

		for (int i = 0; i < _constraints.size(); i++)
			constraintTemplate(
				(org.omg.mof.Model.Constraint) _constraints.elementAt(i));

		for (int i = 0; i < _attributes_cl.size(); i++)
			attributeTemplate(
				(org.omg.mof.Model.MofAttribute) _attributes_cl.elementAt(i));

		for (int i = 0; i < _operations_cl.size(); i++)
			operationTemplate(
				(org.omg.mof.Model.Operation) _operations_cl.elementAt(i));

		// si la classe est abstraite, on appel la calsse create
		if (!_class.is_abstract())
			classCreateTemplate(_class);
		_out.println("\t} ; // end of interface " + _cformat1 + "Class");
		_out.println();
	}

	public void instanceTemplate(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL instanceTemplate");
		//debut("InstanceTemplate", _class.name());
		String _cformat1 = helper.format1(_class.name());
		String _cformat2 = helper.format2(_class.name());
		_out.print("interface " + _cformat1 + ": " + _cformat1 + "Class");

		//clacul des super classes et les ordonnes
		java.util.Vector _classes_ordered = helper.superClassesOrdered(_class);

		//(_classes_ordered.size()-1) pour ne pas compter la classe
		for (int i = 0; i < (_classes_ordered.size() - 1); i++) {
			String _superformat1 =
				helper.format1(
					((org.omg.mof.Model.Class) _classes_ordered.elementAt(i))
						.name());
			_out.print(", " + _superformat1);
		}

		_out.println("{");
		org.omg.mof.Model.ModelElement[] _contents = _class.contents();

		//Calcul des reference et des attributs et des opration d'une classes
		java.util.Vector _references = helper.referencesForClass(_class);
		java.util.Vector _attributes_in =
			helper.attributsForClass(
				_class,
				org.omg.mof.Model.ScopeKind.instance_level,
				false);
		java.util.Vector _operations_in =
			helper.operationsForClass(
				_class,
				org.omg.mof.Model.ScopeKind.instance_level);

		for (int i = 0; i < _attributes_in.size(); i++)
			attributeTemplate(
				(org.omg.mof.Model.MofAttribute) _attributes_in.elementAt(i));

		for (int i = 0; i < _operations_in.size(); i++)
			operationTemplate(
				(org.omg.mof.Model.Operation) _operations_in.elementAt(i));

		for (int i = 0; i < _references.size(); i++)
			referenceTemplate(
				(org.omg.mof.Model.Reference) _references.elementAt(i));

		_out.println("\t} ; // end of interface " + _cformat1);
	}

	public void attributeTemplate(org.omg.mof.Model.MofAttribute _attribute)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL attributeTemplate");
		if (_attribute
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			annotationTemplate(_attribute.annotation());
			String _aformat1 = idlType(_attribute.type());
			String _aformat2 = helper.format2(_attribute.name());
			org.omg.mof.Model.MultiplicityType _multiplicity =
				_attribute.multiplicity();
			int _upper = _multiplicity.upper;
			int _lower = _multiplicity.lower;
			boolean _is_ordered = _multiplicity.isOrdered;
			boolean _is_unique = _multiplicity.isUnique;
			boolean _is_changeable = _attribute.is_changeable();
			boolean _is_derived = _attribute.is_derived();

			if ((_lower == 0) && (_upper == 1))
				_out.println(
					"\t"
						+ _aformat1
						+ " "
						+ _aformat2
						+ "() raises (Reflective::NotSet, Reflective::MofError); ");
			if ((_lower == 1) && (_upper == 1))
				_out.println(
					"\t"
						+ _aformat1
						+ " "
						+ _aformat2
						+ "() raises (Reflective::MofError); ");
			if ((_upper > 1) || (_upper == -1)) {
				// une ligne rajoute
				_out.print("\t" + idlBaseType(_aformat1));
				if (_is_unique && _is_ordered) {
					_out.print("UList  " + _aformat2);
				} else {
					if (_is_ordered) {
						_out.print("List  " + _aformat2);
					} else {
						if (_is_unique) {
							_out.print("Set  " + _aformat2);
						} else
							_out.print("Bag  " + _aformat2);
					}
				}
				_out.println("() raises (Reflective::MofError); ");
			}
			if ((_upper == 1) && (_is_changeable))
				_out.println(
					"\tvoid set_"
						+ _aformat2
						+ " (in "
						+ _aformat1
						+ " new_value) raises (Reflective::MofError); ");
			if (((_upper > 1) || (_upper == -1)) && (_is_changeable)) {
				_out.print("\tvoid set_" + _aformat2 + " (in ");
				// une ligne rajoute
				_out.print(idlBaseType(_aformat1));
				if (_is_unique && _is_ordered) {
					_out.print("UList  ");
				} else {
					if (_is_ordered) {
						_out.print("List  ");
					} else {
						if (_is_unique) {
							_out.print("Set  ");
						} else
							_out.print("Bag  ");
					}
				}
				_out.println(" new_value) raises (Reflective::MofError); ");
			}
			if ((_lower == 0) && (_upper == 1) && (_is_changeable))
				_out.println(
					"\tvoid unset_"
						+ _aformat2
						+ " () raises (Reflective::MofError); ");
			if ((_upper > 1) || (_upper == -1) && (_is_changeable))
				_out.println(
					"\tvoid add_"
						+ _aformat2
						+ " (in "
						+ _aformat1
						+ " new_element) raises (Reflective::MofError); ");
			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered))
				_out.println(
					"\tvoid add_"
						+ _aformat2
						+ "_before ( in "
						+ _aformat1
						+ " new_element, in "
						+ _aformat1
						+ " before_element) raises (Reflective::NotFound, Reflective::MofError); ");
			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_multiplicity.isUnique))
				_out.println(
					"\tvoid add_"
						+ _aformat2
						+ "_at (in "
						+ _aformat1
						+ " new_element, in unsigned long position) raises (Reflective::BadPosition, Reflective::MofError); ");
			if ((_upper > 1) || (_upper == -1) && (_is_changeable))
				_out.println(
					"\tvoid modify_"
						+ _aformat2
						+ " (in "
						+ _aformat1
						+ " old_element, in "
						+ _aformat1
						+ " new_element) raises (Reflective::NotFound, Reflective::MofError); ");
			if ((_upper > 1)
				|| (_upper == -1)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_is_unique))
				_out.println(
					"\tvoid modify_"
						+ _aformat2
						+ "_at (in "
						+ _aformat1
						+ " new_element, in unsigned long position) raises (Reflective::BadPosition, Reflective::MofError); ");
			if ((_upper > 1)
				|| (_upper == -1)
				&& (_upper != _lower)
				&& (_is_changeable))
				_out.println(
					"\tvoid remove_"
						+ _aformat2
						+ " (in "
						+ _aformat1
						+ " old_element ) raises (Reflective::NotFound, Reflective::MofError); ");
			if ((_upper > 1)
				|| (_upper == -1)
				&& (_upper != _lower)
				&& (_is_changeable)
				&& (_is_ordered)
				&& (!_is_unique))
				_out.println(
					"\tvoid remove_"
						+ _aformat2
						+ "_at (in unsigned long position) raises (Reflective::BadPosition, Reflective::MofError); ");
		}
	}
	public void operationTemplate(org.omg.mof.Model.Operation _operation)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL operationTemplate");

		if (_operation
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			String _oformat2 = helper.format2(_operation.name());
			annotationTemplate(_operation.annotation());

			//clacul du contenu
			org.omg.mof.Model.ModelElement[] _contents = _operation.contents();

			// trouver le type de retour s'il y en a
			boolean bool = false;
			int j = 0;
			while (!bool && (j < _contents.length)) {
				System.out.println("Salim");
				org.omg.mof.Model.Parameter _parameter =
					org.omg.mof.Model.ParameterHelper.narrow(_contents[j]);
				if ((_parameter.direction())
					.equals(org.omg.mof.Model.DirectionKind.return_dir)) {
					bool = true;
					String _typeparameter = idlType(_parameter.type());
					org.omg.mof.Model.MultiplicityType _multiplicity =
						_parameter.multiplicity();
					boolean _is_unique = _multiplicity.isUnique;
					boolean _is_ordered = _multiplicity.isOrdered;
					if ((_multiplicity.upper > 1)
						|| (_multiplicity.upper == -1)) {
						_out.print("\t" + idlBaseType(_typeparameter));
						if ((_is_unique) && (_is_ordered)) {
							_out.print("UList  " + _oformat2 + " (");
						} else {
							if (_is_ordered) {
								_out.print("List  " + _oformat2 + " (");
							} else {
								if (_is_unique) {
									_out.print("Set  " + _oformat2 + " (");
								} else
									_out.print("Bag  " + _oformat2 + " (");
							}
						}
					} else
						_out.print(
							"\t" + _typeparameter + "  " + _oformat2 + " (");
				}
				j++;
			}
			if (!bool) {
				_out.print("\tvoid " + _oformat2 + " (");
			}

			// trouver le type et les nom des paramtres restants
			for (int i = 0; i < _contents.length; i++) {
				org.omg.mof.Model.Parameter _parameter =
					org.omg.mof.Model.ParameterHelper.narrow(_contents[i]);

				if (!(_parameter
					.direction()
					.equals(org.omg.mof.Model.DirectionKind.return_dir))) {

					//Calculer les proprits du paramtre courant
					String _pformat2 = helper.format2(_parameter.name());
					String _typeparameter = idlType(_parameter.type());
					org.omg.mof.Model.MultiplicityType _multiplicity =
						_parameter.multiplicity();
					int _upper = _multiplicity.upper;
					int _lower = _multiplicity.lower;
					boolean _is_unique = _multiplicity.isUnique;
					boolean _is_ordered = _multiplicity.isOrdered;
					org.omg.mof.Model.DirectionKind _direction =
						_parameter.direction();

					//crire le paramtre
					if (_direction
						.equals(org.omg.mof.Model.DirectionKind.in_dir))
						_out.print("in ");
					else if (
						_direction.equals(
							org.omg.mof.Model.DirectionKind.out_dir))
						_out.print("out ");
					else if (
						_direction.equals(
							org.omg.mof.Model.DirectionKind.inout_dir))
						_out.print("inout ");

					if ((_upper > 1) || (_upper == -1)) {
						_out.print(idlBaseType(_typeparameter));
						if ((_is_unique) && (_is_ordered)) {
							_out.print("UList  " + _pformat2);
						} else {
							if (_is_ordered) {
								_out.print("List  " + _pformat2);
							} else {
								if (_is_unique) {
									_out.print("Set  " + _pformat2);
								} else
									_out.print("Bag  " + _pformat2);
							}
						}
					} else
						_out.print(_typeparameter + "  " + _pformat2);
					if (i != (_contents.length - 1))
						_out.println(" ,");
				}
			}
			_out.print(") raises (");

			//traitement des exceptions
			org.omg.mof.Model.MofException[] _exceptions =
				_operation.exceptions();
			for (int i = 0; i < _exceptions.length; i++) {
				org.omg.mof.Model.MofException _exception =
					org.omg.mof.Model.MofExceptionHelper.narrow(_exceptions[i]);
				String _eformat1 = helper.format1(_exception.name());
				_out.print(_eformat1);
				_out.println(" ,");
			}
			_out.println("Reflective::MofError );");

			//traitements des contraintes
			org.omg.mof.Model.Constraint[] _constraints =
				_operation.constraints();
			for (int i = 0; i < _constraints.length; i++) {
				org.omg.mof.Model.Constraint _constraint =
					org.omg.mof.Model.ConstraintHelper.narrow(_constraints[i]);
				constraintTemplate(_constraint);
			}
		}
	}

	public void classCreateTemplate(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL classCreateTemplate");

		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			String _typeclass = idlType(_class);
			String _cformat2 = helper.format2(_class.name());
			_out.print("\t" + _typeclass + " create_" + _cformat2 + " (");

			//Calcul des attributs
			java.util.Vector _attributes_nd =
				helper.allAttributsForClasses(
					_class,
					org.omg.mof.Model.ScopeKind.instance_level,
					true);

			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _aformat2 = helper.format2(_current.name());
				String _typeattribute = idlType(_current.type());
				org.omg.mof.Model.MultiplicityType _multiplicity =
					_current.multiplicity();
				boolean _is_unique = _multiplicity.isUnique;
				boolean _is_ordered = _multiplicity.isOrdered;
				if ((_multiplicity.upper > 1) || (_multiplicity.upper == -1)) {
					if (_is_unique && _is_ordered) {
						_out.print(
							"in "
								+ idlBaseType(_typeattribute)
								+ "UList  "
								+ _aformat2);
					} else {
						if (_is_ordered) {
							_out.print(
								"in "
									+ idlBaseType(_typeattribute)
									+ "List  "
									+ _aformat2);
						} else {
							if (_is_unique) {
								_out.print(
									"in "
										+ idlBaseType(_typeattribute)
										+ "Set  "
										+ _aformat2);
							} else
								_out.print(
									"in "
										+ idlBaseType(_typeattribute)
										+ "Bag  "
										+ _aformat2);
						}
					}
				} else
					_out.print("in " + _typeattribute + "  " + _aformat2);
				if (i != (_attributes_nd.size() - 1))
					_out.print(" ,");
			}
			_out.println(") raises (Reflective::MofError);");
		}
	}

	public void referenceTemplate(org.omg.mof.Model.Reference _reference)
		throws org.omg.mof.Reflective.MofError {

		logger.log(Level.FINE, "IDL referenceTemplate");
		if (_reference
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			annotationTemplate(_reference.annotation());
			String _rformat1 = helper.format1(_reference.name());
			String _rformat2 = helper.format2(_reference.name());
			String _typereference = idlType(_reference.type());
			org.omg.mof.Model.MultiplicityType _multiplicity =
				_reference.multiplicity();
			int _upper = _multiplicity.upper;
			int _lower = _multiplicity.lower;

			if ((_lower == 0) && (_upper == 1))
				_out.println(
					"\t"
						+ _typereference
						+ "  "
						+ _rformat2
						+ "() raises (Reflective::NotSet, Reflective::MofError);");

			if ((_lower == 1) && (_upper == 1))
				_out.println(
					"\t"
						+ _typereference
						+ "  "
						+ _rformat2
						+ "() raises (Reflective::MofError);");

			if ((_upper > 1) || (_upper == -1)) {
				// une ligne rajoute
				_out.print("\t" + idlBaseType(_typereference));
				if (_multiplicity.isUnique && _multiplicity.isOrdered) {
					_out.print("UList  ");
				} else {
					if (_multiplicity.isOrdered) {
						_out.print("List  ");
					} else {
						if (_multiplicity.isUnique) {
							_out.print("Set  ");
						} else
							_out.print("Bag  ");
					}
				}
				_out.println(_rformat2 + "() raises (Reflective::MofError);");
			}

			if ((_upper == 1) && (_reference.is_changeable()))
				_out.println(
					"\tvoid set_"
						+ _rformat2
						+ " (in "
						+ _typereference
						+ " new_value ) raises (Reflective::MofError);");

			if (((_upper > 1) || (_upper == -1))
				&& (_reference.is_changeable())) {
				_out.print("\tvoid set_" + _rformat2 + " ( ");
				if (_multiplicity.isUnique && _multiplicity.isOrdered) {
					_out.print("in " + idlBaseType(_typereference) + "UList  ");
				} else {
					if (_multiplicity.isOrdered) {
						_out.print(
							"in " + idlBaseType(_typereference) + "List  ");
					} else {
						if (_multiplicity.isUnique) {
							_out.print(
								"in " + idlBaseType(_typereference) + "Set  ");
						} else
							_out.print(
								"in " + idlBaseType(_typereference) + "Bag  ");
					}
				}
				_out.println(" new_value ) raises (Reflective::MofError);");
			}

			if ((_lower == 0) && (_upper == 1) && (_reference.is_changeable()))
				_out.println(
					"\tvoid unset_"
						+ _rformat2
						+ " () raises (Reflective::MofError);");

			if (((_upper > 1) || (_upper == -1))
				&& (_reference.is_changeable()))
				_out.println(
					"\tvoid add_"
						+ _rformat2
						+ " ( in "
						+ _typereference
						+ " new_element ) raises (Reflective::MofError);");

			if (((_upper > 1) || (_upper == -1))
				&& (_multiplicity.isOrdered)
				&& (_reference.is_changeable())) {
				_out.print("\tvoid add_" + _rformat2 + "_before ( ");
				_out.print("in " + _typereference + " new_element, ");
				_out.println(
					"in "
						+ _typereference
						+ " before_element ) raises (Reflective::NotFound, Reflective::MofError);");
			}

			if (((_upper > 1) || (_upper == -1))
				&& (_reference.is_changeable())) {
				_out.print("\tvoid modify_" + _rformat2 + " ( ");
				_out.print("in " + _typereference + " old_element, ");
				_out.println(
					"in "
						+ _typereference
						+ " new_element ) raises (Reflective::NotFound, Reflective::MofError);");
			}

			if (((_upper > 1) || (_upper == -1))
				&& (_lower != _upper)
				&& (_reference.is_changeable())) {
				_out.print("\tvoid remove_" + _rformat2 + " (");
				_out.print("in " + _typereference + " old_element ");
				_out.println(
					" ) raises (Reflective::NotFound, Reflective::MofError);");
			}
		}
	}
}