/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class ClassImplementation {
	//Templates
	Templates templates;
	
	//Helper
	Helper helper;
	
	//Log facility
	 Logger logger = Logger.getLogger("fr.lip6.src.mdafactory.generation.idl2javaImpl.ClassImplementation");	


	// La partie I/O
	private  java.io.PrintWriter _out;

	public  void setOut(String _file)
		throws java.io.FileNotFoundException {
			logger.log(Level.CONFIG , "ClassImplementation set file to "+ _file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
			logger.log(Level.CONFIG , "ClassImplementation set file to "+ _file.getAbsolutePath());
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void closeFile() {
		_out.close();
	}
	public  void generateJava(org.omg.mof.Model.Class _class)
		throws
			org.omg.mof.Reflective.NotSet,
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		_out.println("// le Code gnr de la Class: " + _class.name());
		classImpl(_class);
		closeFile();
	}

	public  void constructeurClass(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError, org.omg.mof.Reflective.NotSet {

		String _nformat1 = helper.format1Idl2JavaConflict(_class.name());
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());

		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			_out.print("\tpublic " + _nformat1 + "Impl(");

			// trouver toutes les attributs classifier_level de cette classe
			java.util.Vector _attributes_nd =
				helper.allAttributsForClasses(
					_class,
					org.omg.mof.Model.ScopeKind.instance_level,
					true);

			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _type_format1 = helper.javaType(_current.type());
				String _aformat2 = helper.format2(_current.name());
				if ((_current.multiplicity().upper > 1)
					|| (_current.multiplicity().upper == -1))
					_out.print(_type_format1 + "[]  " + _aformat2 + "s");
				else
					_out.print(_type_format1 + " " + _aformat2);
				_out.print(", ");
			}
			_out.println(_cformat1 + "Class _proxy){");
			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _aformat2 = helper.format2(_current.name());
				int _lower = _current.multiplicity().lower;
				int _upper = _current.multiplicity().upper;
				if ((_upper > 1) || (_upper == -1)) {
					_out.print(
						"\t\tfor(int i=0;i<" + _aformat2 + "s.length; i++) ");
					_out.print(
						" _"
							+ _aformat2
							+ "s.addElement("
							+ _aformat2
							+ "s[i]);");
				} else {
					_out.println(
						"\t\t_" + _aformat2 + " = " + _aformat2 + " ;");
					if ((_lower == 0) && (_upper == 1))
						_out.println("\t\t_exist_" + _aformat2 + " = true;");
				}
			}
			_out.println("\t\t_class_proxy = _proxy ;");
			_out.println("\t\t  }");
			_out.println("\t}");

		}
	}

	public  void allOfType(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());
		_out.println(
			"\tpublic " + _cformat1 + "[] all_of_type_" + _cformat2 + "() {");
		_out.println(
			"\t\treturn _class_proxy.all_of_type_" + _cformat2 + "();");
		_out.println("\t\t}");
	}

	public  void allOfClasses(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());
		_out.println(
			"\tpublic " + _cformat1 + "[] all_of_class_" + _cformat2 + "() {");
		_out.println(
			"\t\treturn _class_proxy.all_of_class_" + _cformat2 + "();");
		_out.println("\t\t}");
	}

	public  void createClass(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());
		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			_out.print("\tpublic " + _cformat1 + " create_" + _cformat2 + "(");
			java.util.Vector _attributes_nd =
				helper.allAttributsForClasses(
					_class,
					org.omg.mof.Model.ScopeKind.instance_level,
					true);
			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _type_format1 = helper.javaType(_current.type());
				String _aformat2 = helper.format2(_current.name());
				if ((_current.multiplicity().upper > 1)
					|| (_current.multiplicity().upper == -1))
					_out.print(_type_format1 + "[]  " + _aformat2);
				else
					_out.print(_type_format1 + " " + _aformat2);
				if (i != (_attributes_nd.size() - 1))
					_out.print(", ");
			}
			_out.println(") throws org.omg.mof.Reflective.MofError {");
			_out.print("\t\treturn _class_proxy.create_" + _cformat2 + "(");
			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _aformat2 = helper.format2(_current.name());
				_out.print(_aformat2);
				if (i != (_attributes_nd.size() - 1))
					_out.print(", ");

			}
			_out.println(");");
			_out.println("\t\t}");
		}
	}

	public  void classImpl(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {

		//les formats du nom de la classe
		String _nformat1 = helper.format1Idl2JavaConflict(_class.name());
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());

		//Dcalration du Package
		_out.print("package ");

		// Affichage du nom  du package
		_out.println(helper.javaPackage(_class.container()) + " ;");

		_out.println(
			"public class "
				+ _nformat1
				+ "Impl extends "
				+ _cformat1
				+ "POA {");
		_out.println();

		//genrer du code pour RefBaseObject et RefObject
		_out.print(templates.refBaseObjectTemplate());
		_out.println();
		_out.print(templates.refObjectTemplate());

		//Dclaration de classe proxy
		_out.println("\t\tprivate " + _cformat1 + "Class _class_proxy;");

		// Tous les attributs classifier_level
		java.util.Vector _attributes_c =
			helper.allAttributsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level,
				false);
		for (int i = 0; i < _attributes_c.size(); i++) {
			org.omg.mof.Model.MofAttribute _attribute =
				(org.omg.mof.Model.MofAttribute) _attributes_c.elementAt(i);
			if (_attribute
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_attribute =
					templates.attributeTemplate(_attribute);
				_out.println(_code_attribute);
			}
		}

		// Toutes les oprations classifier_level
		java.util.Vector _operations_c =
			helper.allOperationsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level);
		for (int i = 0; i < _operations_c.size(); i++) {
			org.omg.mof.Model.Operation _operation =
				(org.omg.mof.Model.Operation) _operations_c.elementAt(i);
			if (_operation
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_operation =
					templates.operationTemplate(_operation);
				_out.println(_code_operation);
			}
		}

		// Traitement des CreateClass, all_of_type et all_of_classes de la classe et de ses superclasses
		org.omg.mof.Model.GeneralizableElement[] _all_superclasses =
			_class.all_supertypes();
		java.util.Vector _sup_classes = new java.util.Vector();
		for (int i = 0; i < _all_superclasses.length; i++)
			_sup_classes.addElement(
				org.omg.mof.Model.ClassHelper.narrow(_all_superclasses[i]));

		//Ajout de la classe elle mme
		_sup_classes.addElement(_class);

		//Gnrer le code de la mthode Create et de la mthode all_of_classes
		for (int i = 0; i < _sup_classes.size(); i++) {
			org.omg.mof.Model.Class _current =
				(org.omg.mof.Model.Class) _sup_classes.elementAt(i);
			if (!_current.is_abstract()) {
				createClass(_current);
				allOfClasses(_current);
			}
			allOfType(_current);
		}

		// Tous les attributs Instance_level
		java.util.Vector _attributes =
			helper.allAttributsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.instance_level,
				false);
		for (int i = 0; i < _attributes.size(); i++) {
			org.omg.mof.Model.MofAttribute _attribute =
				(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i);
			if (_attribute
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_attribute =
					templates.attributeTemplate(_attribute);
				_out.println(_code_attribute);
			}
		}

		// Toutes les oprations Instance_level
		java.util.Vector _operations =
			helper.allOperationsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.instance_level);
		for (int i = 0; i < _operations.size(); i++) {
			org.omg.mof.Model.Operation _operation =
				(org.omg.mof.Model.Operation) _operations.elementAt(i);
			if (_operation
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_operation =
					templates.operationTemplate(_operation);
				_out.println(_code_operation);
			}
		}

		// Toutes les rfrences Instance et Classifier level
		java.util.Vector _references = helper.allReferencesForClasses(_class);
		for (int i = 0; i < _references.size(); i++) {
			org.omg.mof.Model.Reference _reference =
				(org.omg.mof.Model.Reference) _references.elementAt(i);
			if (_reference
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_reference =
					templates.referenceTemplate(_reference);
				_out.println(_code_reference);
			}
		}
		constructeurClass(_class);
	}
	
	/**
	 * Gets the helper
	 * @return Returns a helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

	/**
	 * Gets the templates
	 * @return Returns a Templates
	 */
	public Templates getTemplates() {
		return templates;
	}
	/**
	 * Sets the templates
	 * @param templates The templates to set
	 */
	public void setTemplates(Templates templates) {
		this.templates = templates;
	}

}