/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

public class ClassProxyImplementation {
	//Templates
	Templates templates;
	
	//Helper
	Helper helper;
	
	//Log facility
	 Logger logger = Logger.getLogger("fr.lip6.src.mdafactory.generation.idl2javaImpl.ClassProxyImplementation");	


	// La partie I/O
	private  java.io.PrintWriter _out;

	public  void setOut(java.io.PrintWriter _output) {
		logger.log( Level.CONFIG, "ClassProxyImplementation setOutput : "+_output);
		_out = _output;
	}
	public  void setOut(String _file)
		throws java.io.FileNotFoundException {
			logger.log( Level.CONFIG, "ClassProxyImplementation setOutput : "+_file);
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void setOut(java.io.File _file)
		throws java.io.FileNotFoundException, java.io.IOException {
			logger.log( Level.CONFIG, "ClassProxyImplementation setOut : "+_file.getAbsolutePath());
		_out =
			new java.io.PrintWriter(new java.io.FileOutputStream(_file), true);
	}

	public  void closeFile() {
		_out.close();
	}
	public  void generateJava(org.omg.mof.Model.Class _class)
		throws
			org.omg.mof.Reflective.NotSet,
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds {
		_out.println("// le Code gnr de la ProxyClass: " + _class.name());
		classProxyImpl(_class);
		closeFile();
	}

	// La partie gnration du code
	public  void allOfType(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError, org.omg.mof.Reflective.NotSet {

		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());

		_out.println(
			"\tpublic " + _cformat1 + "[] all_of_type_" + _cformat2 + "() {");

		// ce vecteur et tableau sont cres pour toutes les classes
		_out.println(
			"\t\tjava.util.Vector all_type_vector = new java.util.Vector();");
		org.omg.mof.Model.Class[] _sub_classes = helper.subClasses(_class);

		for (int i = 0; i < _sub_classes.length; i++) {
			org.omg.mof.Model.Class _class_temp = _sub_classes[i];
			if (!_class_temp.is_abstract()) {
				String _sformat1 = helper.javaQualifiedName(_class_temp);
				String _sformat2 = helper.format2(_class_temp.name());

				//mettre tous les retours de la mthode all_classes des sous classes
				_out.println(
					"\t\t"
						+ _sformat1
						+ "[] "
						+ "_"
						+ _sformat2
						+ " =_model_package."
						+ _sformat2
						+ "_ref().all_of_class_"
						+ _sformat2
						+ "();");
				_out.println(
					"\t\tfor(int i=0; i<"
						+ "_"
						+ _sformat2
						+ ".length ; i++) all_type_vector.addElement("
						+ "_"
						+ _sformat2
						+ "[i]);");
			}
		}
		if (!_class.is_abstract())
			_out.println(
				"\t\tfor(int i=0; i< all_class_vector_"
					+ _cformat2
					+ ".size() ; i++) all_type_vector.addElement(("
					+ _cformat1
					+ ")all_class_vector_"
					+ _cformat2
					+ ".elementAt(i));");
		_out.println(
			"\t\t"
				+ _cformat1
				+ "[] all_type = new "
				+ _cformat1
				+ "[all_type_vector.size()];");
		_out.println(
			"\t\tfor (int i=0; i< all_type_vector.size(); i++) all_type[i]= ("
				+ _cformat1
				+ ")all_type_vector.elementAt(i);");
		_out.println("\t\treturn all_type; ");
		_out.println("\t} ");

	}

	public  void allOfClasses(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());
		_out.println(
			"\t\tjava.util.Vector all_class_vector_"
				+ _cformat2
				+ " = new java.util.Vector();");
		_out.println(
			"\tpublic " + _cformat1 + "[] all_of_class_" + _cformat2 + "() {");
		_out.println(
			"\t\t"
				+ _cformat1
				+ "[] _"
				+ _cformat2
				+ " = new "
				+ _cformat1
				+ "[all_class_vector_"
				+ _cformat2
				+ ".size()];");
		_out.println(
			"\t\tfor (int i=0; i< all_class_vector_"
				+ _cformat2
				+ ".size(); i++) _"
				+ _cformat2
				+ "[i]= ("
				+ _cformat1
				+ ")all_class_vector_"
				+ _cformat2
				+ ".elementAt(i);");
		_out.println("\t\treturn _" + _cformat2 + "; ");
		_out.println("\t} ");
	}

	public  void createClass(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());
		
		
		//if (_class.visibility().equals(org.omg.mof.Model.VisibilityKind.public_vis)){
		_out.print("\tpublic " + _cformat1 + " create_" + _cformat2 + "(");

		// trouver toutes les attributs de cette classe
		java.util.Vector _attributes_nd =
			helper.allAttributsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.instance_level,
				true);
		for (int i = 0; i < _attributes_nd.size(); i++) {
			org.omg.mof.Model.MofAttribute _current =
				(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(i);
			String _type_format1 = helper.javaType(_current.type());
			String _aformat2 = helper.format2(_current.name());
			if ((_current.multiplicity().upper > 1)
				|| (_current.multiplicity().upper == -1)) {
				_out.print(_type_format1 + "[]  " + _aformat2);
			} else
				_out.print(_type_format1 + " " + _aformat2);
			if (i != (_attributes_nd.size() - 1))
				_out.print(", ");
		}
		_out.println(") throws org.omg.mof.Reflective.MofError {");
		_out.print(
			"\t\t"
				+ _cformat1
				+ "Impl _"
				+ _cformat2
				+ " = new "
				+ _cformat1
				+ "Impl(");
		for (int i = 0; i < _attributes_nd.size(); i++) {
			org.omg.mof.Model.MofAttribute _current =
				(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(i);
			String _aformat2 = helper.format2(_current.name());
			_out.print(_aformat2);
			_out.print(", ");
		}
		_out.println("_this());");
		_out.println("\t\ttry {");
		_out.println("\t\t_poa().activate_object(_" + _cformat2 + ");");
		_out.println(
			"\t\torg.omg.CORBA.Object obj = _poa().servant_to_reference(_"
				+ _cformat2
				+ ");");
		_out.println(
			"\t\t"
				+ _cformat1
				+ " _ref = "
				+ _cformat1
				+ "Helper.narrow(obj);");
		_out.println(
			"\t\tall_class_vector_" + _cformat2 + ".addElement(_ref);");
		_out.println("\t\treturn _ref;");
		_out.println("\t\t}");
		_out.println("\t\tcatch(java.lang.Exception ex){");
		_out.println("\t\tex.printStackTrace();");
		_out.println("\t\tSystem.exit(0);");
		_out.println("\t\t}");
		_out.println("\treturn null;");
		_out.println("\t}");
		//    }
	}
	
	public  void constructeurClass(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError, org.omg.mof.Reflective.NotSet {

		//String _nformat1 = helper.format1Idl2JavaConflict(_class.name());
		String _nformat1 = helper.format1(_class.name());
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());

		if (_class
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
			_out.print("\tpublic " + _nformat1 + "ClassImpl(");

			// trouver toutes les attributs classifier_level de cette classe
			java.util.Vector _attributes_nd =
				helper.allAttributsForClasses(
					_class,
					org.omg.mof.Model.ScopeKind.classifier_level,
					true);

			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _type_format1 = helper.javaType(_current.type());
				String _aformat2 = helper.format2(_current.name());
				if ((_current.multiplicity().upper > 1)
					|| (_current.multiplicity().upper == -1))
					_out.print(_type_format1 + "[]  " + _aformat2 + "s");
				else
					_out.print(_type_format1 + " " + _aformat2);
				_out.print(", ");
			}
			_out.println(
				helper.format1Idl2JavaConflict(_class.container().name()+"Package")
					+ " _model_package) {");
			for (int i = 0; i < _attributes_nd.size(); i++) {
				org.omg.mof.Model.MofAttribute _current =
					(org.omg.mof.Model.MofAttribute) _attributes_nd.elementAt(
						i);
				String _aformat2 = helper.format2(_current.name());
				int _lower = _current.multiplicity().lower;
				int _upper = _current.multiplicity().upper;
				if ((_upper > 1) || (_upper == -1)) {
					_out.print(
						"\t\tfor(int i=0;i<" + _aformat2 + "s.length; i++) ");
					_out.print(
						" _"
							+ _aformat2
							+ "s.addElement("
							+ _aformat2
							+ "s[i]);");
				} else {
					_out.println(
						"\t\t_" + _aformat2 + " = " + _aformat2 + " ;");
					if ((_lower == 0) && (_upper == 1))
						_out.println("\t\t_exist_" + _aformat2 + " = true;");
				}
			}
			_out.println("\t\tthis._model_package = _model_package ;");
			_out.println("\t}");
			_out.println("}");

		}
	}

	public  void classProxyImpl(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.NotSet, org.omg.mof.Reflective.MofError {

		//les formats du nom de la classe
		//String _nformat1 = helper.format1Idl2JavaConflict(_class.name());
		String _nformat1 = helper.format1(_class.name());
		String _cformat1 = helper.javaQualifiedName(_class);
		String _cformat2 = helper.format2(_class.name());

		//Dcalration du Package
		_out.print("package ");

		// Affichage du nom du package
		_out.println(helper.javaPackage(_class.container()) + ";");

		_out.println(
			"public class "
				+ _nformat1
				+ "ClassImpl extends "
				+ _cformat1
				+ "ClassPOA {");
		_out.println(
			"\t\t"
				+ helper.format1Idl2JavaConflict(_class.container().name()+"Package")
				+ " _model_package;");

		//genrer du code pour RefBaseObject et RefObject
		_out.print(templates.refBaseObjectTemplate());
		_out.println();
		_out.print(templates.refObjectTemplate());

		// Tous les attributs classifier_level
		java.util.Vector _attributes =
			helper.allAttributsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level,
				false);
		for (int i = 0; i < _attributes.size(); i++) {
			org.omg.mof.Model.MofAttribute _attribute =
				(org.omg.mof.Model.MofAttribute) _attributes.elementAt(i);
			if (_attribute
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_attribute =
					templates.attributeTemplate(_attribute);
				_out.println(_code_attribute);
			}
		}

		// Toutes les oprations classifier_level
		java.util.Vector _operations =
			helper.allOperationsForClasses(
				_class,
				org.omg.mof.Model.ScopeKind.classifier_level);
		for (int i = 0; i < _operations.size(); i++) {
			org.omg.mof.Model.Operation _operation =
				(org.omg.mof.Model.Operation) _operations.elementAt(i);
			if (_operation
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _code_operation =
					templates.operationTemplate(_operation);
				_out.println(_code_operation);
			}
		}

		// Traitement des CreateClass, all_of_type et all_of_classes de la classe et de ses superclasses
		org.omg.mof.Model.GeneralizableElement[] _all_superclasses =
			_class.all_supertypes();
		java.util.Vector _sup_classes = new java.util.Vector();
		for (int i = 0; i < _all_superclasses.length; i++)
			_sup_classes.addElement(
				org.omg.mof.Model.ClassHelper.narrow(_all_superclasses[i]));

		//    //Ajout de la classe elle mme
		//    _sup_classes.addElement(_class);
		//
		//    for(int i=0; i< _sup_classes.size(); i++){
		//      org.omg.mof.Model.Class _current = (org.omg.mof.Model.Class)_sup_classes.elementAt(i);
		//
		//     //Gnrer le code de la mthode Create et de la mthode all_of_classes
		//     if(!_current.is_abstract()){
		//	CreateClass(_current);
		//        AllOfClasses(_current);
		//      }
		//
		//     //Gnrer le code de la mthode AllOfType
		//      AllOfType(_current) ;
		//    }
		//    ConstructeurClass(_class);
		//  }
		//Ajout de la classe elle mme

		//les modif
		//ne pas rajouter
		//_sup_classes.addElement(_class);

		for (int i = 0; i < _sup_classes.size(); i++) {
			org.omg.mof.Model.Class _current =
				(org.omg.mof.Model.Class) _sup_classes.elementAt(i);
			if (_current
				.visibility()
				.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {
				String _cu_format1 = helper.javaQualifiedName(_current);
				String _cu_format2 = helper.format2(_current.name());

				//Gnrer le code de la mthode Create et de la mthode all_of_classes
				if (!_current.is_abstract()) {

					//CreateClass des SuperClasses
					_out.print(
						"\tpublic "
							+ _cu_format1
							+ " create_"
							+ _cu_format2
							+ "(");

					// trouver toutes les attributs de cette classe
					java.util.Vector _attributes_nd =
						helper.allAttributsForClasses(
							_class,
							org.omg.mof.Model.ScopeKind.instance_level,
							true);
					for (int j = 0; j < _attributes_nd.size(); j++) {
						org.omg.mof.Model.MofAttribute _current_at =
							(
								org
									.omg
									.mof
									.Model
									.MofAttribute) _attributes_nd
									.elementAt(
								j);
						String _type_format1 =
							helper.javaType(_current_at.type());
						String _aformat2 = helper.format2(_current_at.name());
						if ((_current_at.multiplicity().upper > 1)
							|| (_current_at.multiplicity().upper == -1)) {
							_out.print(_type_format1 + "[]  " + _aformat2);
						} else
							_out.print(_type_format1 + " " + _aformat2);
						if (j != (_attributes_nd.size() - 1))
							_out.print(", ");
					}
					_out.println(") throws org.omg.mof.Reflective.MofError {");
					_out.print(
						"\t\t"
							+ _cu_format1
							+ " _"
							+ _cu_format2
							+ " = _model_package."
							+ _cu_format2
							+ "_ref().create_"
							+ _cu_format2
							+ "(");
					for (int j = 0; j < _attributes_nd.size(); j++) {
						org.omg.mof.Model.MofAttribute _current_at =
							(
								org
									.omg
									.mof
									.Model
									.MofAttribute) _attributes_nd
									.elementAt(
								j);
						String _aformat2 = helper.format2(_current_at.name());
						_out.print(_aformat2);
						if (j != (_attributes_nd.size() - 1))
							_out.print(", ");
					}
					_out.println(");");
					_out.println("\t\treturn _" + _cu_format2 + "; ");
					_out.println("\t} ");

					//AllofClasses des SuperClasses
					_out.println(
						"\tpublic "
							+ _cu_format1
							+ "[] all_of_class_"
							+ _cu_format2
							+ "() {");
					_out.println(
						"\t\t"
							+ _cu_format1
							+ "[] _"
							+ _cu_format2
							+ " = _model_package."
							+ _cu_format2
							+ "_ref().all_of_class_"
							+ _cu_format2
							+ "();");
					_out.println("\t\treturn _" + _cu_format2 + "; ");
					_out.println("\t} ");
				}

				//Gnrer le code de la mthode AllOfType de la classe courante
				_out.println(
					"\tpublic "
						+ _cu_format1
						+ "[] all_of_type_"
						+ _cu_format2
						+ "() {");
				_out.println(
					"\t\t"
						+ _cu_format1
						+ "[] _"
						+ _cu_format2
						+ " = _model_package."
						+ _cu_format2
						+ "_ref().all_of_type_"
						+ _cu_format2
						+ "();");
				_out.println("\t\treturn _" + _cu_format2 + "; ");
				_out.println("\t} ");
			}
		}

		//Gnrer le code de la mthode AllOfType et AllofClasses et create Class  Ade la classe courante
		if (!_class.is_abstract()) {
			createClass(_class);
			allOfClasses(_class);
		}

		allOfType(_class);

		constructeurClass(_class);
	}
	/**
	 * Gets the helper
	 * @return Returns a helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

	/**
	 * Gets the templates
	 * @return Returns a Templates
	 */
	public Templates getTemplates() {
		return templates;
	}
	/**
	 * Sets the templates
	 * @param templates The templates to set
	 */
	public void setTemplates(Templates templates) {
		this.templates = templates;
	}

}
