/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.idl2javaImpl;

import fr.lip6.src.modfact.util.Helper;

public class GenerationIDL2JavaImplMOF1_1 {
	//Templates
	Helper helper;
	
	Templates templates;

	
	String directory = ".\\code\\";

	public  void generateJava(org.omg.mof.Model.Package _package)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.CORBA.TypeCodePackage.Bounds,
			org.omg.mof.Reflective.NotSet,
			java.io.FileNotFoundException {

		if (_package
			.visibility()
			.equals(org.omg.mof.Model.VisibilityKind.public_vis)) {

			if (helper == null) {
				helper = new Helper();
			}
			if (templates == null) {
				templates = new Templates();
				templates.setHelper(helper);
			}

			org.omg.mof.Model.ModelElement[] _contents = _package.contents();
			java.util.Vector _packages = new java.util.Vector();
			java.util.Vector _classes = new java.util.Vector();
			java.util.Vector _associations = new java.util.Vector();

			for (int i = 0; i < _contents.length; i++) {
				if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id())) {
					org.omg.mof.Model.Class _class =
						org.omg.mof.Model.ClassHelper.narrow(_contents[i]);
					_classes.addElement(_class);

					//Claculer les contenus des classes pour les utilser aprs
					helper.allContentsOfClasses(_class);
				} else
					if (_contents[i]._is_a(org.omg.mof.Model.PackageHelper.id()))
						_packages.addElement(org.omg.mof.Model.PackageHelper.narrow(_contents[i]));
					else
						if (_contents[i]._is_a(org.omg.mof.Model.AssociationHelper.id()))
							_associations.addElement(
								org.omg.mof.Model.AssociationHelper.narrow(_contents[i]));
			}

			//Traitemement du Pacakge
			String _file_name1 =
				directory + helper.format1Idl2JavaConflict(_package.name() + "Package")+"Impl.java";
			PackageImplementation packageImpl = new PackageImplementation();
			packageImpl.setOut(_file_name1);
			packageImpl.setHelper(helper);
			packageImpl.setTemplates(templates);
			packageImpl.generateJava(_package);
			packageImpl.closeFile();
			
			_file_name1 =
				directory + helper.format1Idl2JavaConflict(_package.name() + "PackageFactory")+"Impl.java";
			PackageFactoryImplementation packageFactoryImpl = new PackageFactoryImplementation();
			packageFactoryImpl.setOut(_file_name1);
			packageFactoryImpl.setHelper(helper);
			packageFactoryImpl.generateJava(_package);
			packageFactoryImpl.closeFile();

			//Traitement des Classes
			java.util.Vector _classes_ordered = new java.util.Vector();
			while (_classes.size() != 0) {
				org.omg.mof.Model.Class _courant = null;
				for (int i = 0; i < _classes.size(); i++) {
					_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes = _courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (helper.contains(_classes, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_classes_ordered.addElement(_courant);
						_classes.removeElement(_courant);
					}
				}
			}

			for (int i = 0; i < _classes_ordered.size(); i++) {
				org.omg.mof.Model.Class _class =
					(org.omg.mof.Model.Class) _classes_ordered.elementAt(i);
				if (_class.visibility() == org.omg.mof.Model.VisibilityKind.public_vis) {

					// Cette Partie gnre toutes les ClasseProxy
					String _file_name2 =
						directory + helper.format1Idl2JavaConflict(_class.name() + "Class")+"Impl.java";
					ClassProxyImplementation classProxyImpl = new ClassProxyImplementation();
					classProxyImpl.setOut(_file_name2);
					classProxyImpl.setHelper(helper);
					classProxyImpl.setTemplates(templates);
					classProxyImpl.generateJava(_class);
					classProxyImpl.closeFile();

					// Cette partie gnre toutes les Classes non abstraites
					if (!(_class.is_abstract())) {
						_file_name2 = directory + helper.format1Idl2JavaConflict(_class.name())+"Impl.java";
						ClassImplementation classImpl = new ClassImplementation();
						classImpl.setOut(_file_name2);
						classImpl.setHelper(helper);
						classImpl.setTemplates(templates);
						classImpl.generateJava(_class);
						classImpl.closeFile();
					}
				}
			}

			//Traitement des Associations
			for (int i = 0; i < _associations.size(); i++) {
				org.omg.mof.Model.Association _association =
					(org.omg.mof.Model.Association) _associations.elementAt(i);
				if (_association.visibility() == org.omg.mof.Model.VisibilityKind.public_vis) {
					String _file_name =
						directory + helper.format1Idl2JavaConflict(_association.name())+"Impl.java";
					AssociationImplementation associationImpl = new AssociationImplementation();
					associationImpl.setOut(_file_name);
					associationImpl.setHelper(helper);
					associationImpl.setTemplates(templates);
					associationImpl.generateJava(_association);
					associationImpl.closeFile();
				}
			}
		} else {
		}
	}

	/**
	 * Gets the directory
	 * @return Returns a String
	 */
	public  String getDirectory() {
		return directory;
	}
	/**
	 * Sets the directory
	 * @param directory The directory to set
	 */
	public  void setDirectory(String direct) {
		directory = direct;
	}

	/**
	 * Gets the helper
	 * @return Returns a Helper
	 */
	public Helper getHelper() {
		return helper;
	}
	/**
	 * Sets the helper
	 * @param helper The helper to set
	 */
	public void setHelper(Helper helper) {
		this.helper = helper;
	}

	/**
	 * Gets the templates
	 * @return Returns a Templates
	 */
	public Templates getTemplates() {
		return templates;
	}
	/**
	 * Sets the templates
	 * @param templates The templates to set
	 */
	public void setTemplates(Templates templates) {
		this.templates = templates;
	}

}