/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.jmi;

import org.omg.mof.Model.Association;
import org.omg.mof.Model.AssociationEnd;
import org.omg.mof.Reflective.MofError;

/**
 * 
 */
public class AssociationInterfaceTemplate extends CommonInterfaceTemplate {

	public void associationTemplate(Association association) throws MofError {
		out.println("public interface "+helper.jmiAssociationName(association)+" extends javax.jmi.reflect.RefAssociation {\n");
		AssociationEnd[] ends = helper.associationEnds(association);
		String classEnd0 = helper.jmiClassifierName(ends[0].type());
		String classEnd1 = helper.jmiClassifierName(ends[1].type());
		String end0 = ends[0].name();
		String end1 = ends[1].name();
		out.println("\tpublic boolean exists("+classEnd0+" "+end0+","+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException;\n");
		//if associationEnd0 is single valued and isNavigable
		if (ends[0].is_navigable() && ends[0].multiplicity().upper<2) out.println("\tpublic "+classEnd0+" get"+end0+"("+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException;\n");
		//if associationEnd0 is multivalued, isOrdered is false, and isNavigable
		if (ends[0].is_navigable() && !ends[0].multiplicity().isOrdered && ends[0].multiplicity().upper>1) {
			out.println("\tpublic Collection get"+end0+"("+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException;\n");
		}
		//if associationEnd0 is multivalued, isOrdered, and isNavigable
		if (ends[0].is_navigable() && ends[0].multiplicity().isOrdered && ends[0].multiplicity().upper>1) {
			out.println("\tpublic List get"+end0+"("+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException;\n");
		}
		
		//if associationEnd1 is single valued and isNavigable
		if (ends[1].is_navigable() && ends[1].multiplicity().upper<2) out.println("\tpublic "+classEnd1+" get"+end1+"("+classEnd0+" "+end0+") throws javax.jmi.reflect.JmiException;\n");
		//if associationEnd1 is multivalued, isOrdered is false, and isNavigable
		if (ends[1].is_navigable() && !ends[1].multiplicity().isOrdered && ends[1].multiplicity().upper>1) {
			out.println("\tpublic Collection get"+end1+"("+classEnd0+" "+end0+") throws javax.jmi.reflect.JmiException;\n");
		}
		//if associationEnd1 is multivalued, isOrdered, and isNavigable
		if (ends[1].is_navigable() && ends[1].multiplicity().isOrdered && ends[1].multiplicity().upper>1) {
			out.println("\tpublic List get"+end1+"("+classEnd0+" "+end0+") throws javax.jmi.reflect.JmiException;\n");
		}
		
		//if associationEnd0 and associationEnd1 isChangeable
		if (ends[0].is_changeable() && ends[1].is_changeable()) {
			out.println("\tpublic void add("+classEnd0+" "+end0+","+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException;\n");
			out.println("\tpublic void remove("+classEnd0+" "+end0+","+classEnd1+" "+end1+") throws javax.jmi.reflect.JmiException , javax.jmi.reflect.NotFoundException;\n");
		}
		
		out.println("}");
	}
}
