/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.generation.jmi;

import org.omg.CORBA.TypeCode;
import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.CORBA.TypeCodePackage.Bounds;
import org.omg.mof.Model.DataType;
import org.omg.mof.Reflective.MofError;

/**
 * 
 */
public class EnumerationTypeImplementationTemplate extends CommonImplementationTemplate {
	public void enumerationTypeTemplate(DataType type) throws MofError , BadKind , Bounds{
		//<<ANNOTATION TEMPLATE>>
		out.println("public interface "+type.name()+"Enum implements "+type.name()+" {");
		//for each enumeration literal
		TypeCode tc = type.type_code();
		for (int i=0 ; i < tc.member_count() ; i++) {
			out.println("\tpublic static final "+tc.member_label(i)+"= new "+type.name()+"Enum(\""+tc.member_label(i)+"\");");
		}
		
		out.println("\tprivate static final List typeName;");
		out.println("\tprivate final String literalName;");
		out.println("\tstatic {");
		out.println("\t\tArrayList temp = new ArrayList();");
		//for each part of the fully qualified name
		for (int i=0 ; i < tc.member_count() ; i++) {
			out.println("\t\ttemp.add(\""+tc.member_label(i)+"\");");
		}
		out.println("\t\ttypeName = Collections.unmodifiableList(temp);");
		out.println("\t}");
		
		out.println("\tprivate "+type.name()+"Enum(String literalName) {");
		out.println("\t\tthis.literalName = literalName;");
		out.println("\t}");
		
		out.println("\tpublic String toString() {");
		out.println("\t\treturn literalName;");
		out.println("\t}");
		
		out.println("\t\tpublic List refTypeName() {");
		out.println("\treturn typeName;");
		out.println("\t}");
		
		out.println("\tpublic boolean equals(Object o) {");
		out.println("\t\tif (o==null) {");
		out.println("\t\t\treturn false;");
		out.println("\t\t} else {");
		out.print("\t\t\treturn ((o instanceof javax.jmi.reflect.RefEnum) && ");
		out.print("((javax.jmi.reflect.RefEnum) o).refTypeName().equals(typeName)");
		out.println("&& ((javax.jmi.reflect.RefEnum) o).toString().equals(literalName));");
		out.println("\t\t}");
		out.println("\t}");
		
		out.println("}");
	}
}
