/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.io;

import fr.lip6.src.modfact.util.*;

import java.io.InputStream;

import javax.xml.parsers.*;

import org.omg.mof.Model.VisibilityKind;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ImportFromRose {

	//Dclaration des Factory
	private org.omg.mof.Model.PackageClass _package_class;
	private org.omg.mof.Model.ClassClass _class_class;
	private org.omg.mof.Model.MofAttributeClass _attribute_class;
	private org.omg.mof.Model.ReferenceClass _reference_class;
	private org.omg.mof.Model.AssociationClass _association_class;
	private org.omg.mof.Model.AssociationEndClass _association_end_class;
	private org.omg.mof.Model.RefersTo _refers_to_class;
	private org.omg.mof.Model.Exposes _exposes_class;
	private org.omg.mof.Model.DataTypeClass _datatype_class;
	private org.omg.mof.Model.ConstantClass _constant_class;
	private org.omg.mof.Model.ConstraintClass _constraint_class;
	private org.omg.mof.Model.TagClass _tag_class;
	private org.omg.mof.Model.OperationClass _operation_class;
	private org.omg.mof.Model.ParameterClass _parameter_class;
	private org.omg.mof.Model.MofExceptionClass _exception_class;

	// Dclaration
	private org.omg.CORBA.ORB _orb;
	private org.w3c.dom.Document _document;

	// Hashtables pour typer  les attributs et les paramtre et rajouter les supertypes
	private java.util.Hashtable _types = new java.util.Hashtable();
	private java.util.Hashtable _elementHisType = new java.util.Hashtable();
	private java.util.Hashtable _elementHisSupertypes =
		new java.util.Hashtable();

	//Hashtables pour les tags
	private java.util.Hashtable _tags = new java.util.Hashtable();
	private java.util.Hashtable _elementHisTag = new java.util.Hashtable();

	//Hashtables pour les Exception  lier aux oprations 
	private java.util.Hashtable _Id2Operation = new java.util.Hashtable();
	private java.util.Hashtable _Exception4Operations =
		new java.util.Hashtable();

	// Hashtables pour les typer les rfrences et les lier aux associationEnd
	private java.util.Hashtable _OtherEnd = new java.util.Hashtable();
	private java.util.Hashtable _Id2End = new java.util.Hashtable();
	private java.util.Hashtable _referencedEndTable = new java.util.Hashtable();
	private java.util.Hashtable _ConstantValue = new java.util.Hashtable();

	//Hashtable pour les strotypes des types IDL CORBA: CORBAStruct.. 
	private java.util.Hashtable _Id2Stereotype = new java.util.Hashtable();

	// initialisation
	public void initiate(
		org.omg.mof.Model.ModelPackage _model_package,
		org.omg.CORBA.ORB orb)
		throws org.omg.mof.Reflective.MofError {

		//creation des Factory
		_package_class = _model_package.package_ref();
		_class_class = _model_package.class_ref();
		_attribute_class = _model_package.mof_attribute_ref();
		_reference_class = _model_package.reference_ref();
		_association_class = _model_package.association_ref();
		_association_end_class = _model_package.association_end_ref();
		_refers_to_class = _model_package.refers_to_ref();
		_exposes_class = _model_package.exposes_ref();
		_datatype_class = _model_package.data_type_ref();
		_constant_class = _model_package.constant_ref();
		_constraint_class = _model_package.constraint_ref();
		_tag_class = _model_package.tag_ref();
		_operation_class = _model_package.operation_ref();
		_parameter_class = _model_package.parameter_ref();
		_exception_class = _model_package.mof_exception_ref();
		_orb = orb;
	}

	public org.omg.mof.Model.Package parse(String _fichier)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {

		// Charger le document
		java.io.FileInputStream _xml_input_file =
			new java.io.FileInputStream(_fichier);
		
		return parse(_xml_input_file);
	}

	public org.omg.mof.Model.Package parse(InputStream _xml_input_file)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException,
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {

		// le package
		org.omg.mof.Model.Package _package = null;

		// les types primitifs
		java.util.Vector _primitif_types = new java.util.Vector();

		javax.xml.parsers.DocumentBuilderFactory _factory =
			javax.xml.parsers.DocumentBuilderFactory.newInstance();
		javax.xml.parsers.DocumentBuilder _builder =
			_factory.newDocumentBuilder();

		// Charger le document
		org.w3c.dom.Document _doc = _builder.parse(_xml_input_file);
		_document = _doc;

		// Parser le document
		org.w3c.dom.Element _model = _doc.getDocumentElement();

		//enlever les espaces
		delSpaces(_model);

		//rcuprer le contenus
		org.w3c.dom.Element _modelElement =
			(org.w3c.dom.Element) _model
				.getElementsByTagName("XMI.content")
				.item(0)
				.getFirstChild();
		org.w3c.dom.Element _namespace =
			(org.w3c.dom.Element) _modelElement
				.getElementsByTagName("Foundation.Core.Namespace.ownedElement")
				.item(0);
		org.w3c.dom.NodeList _contents = _namespace.getChildNodes();

		//d'abort le traitement des types primitifs est les strotypes 
		for (int i = 0; i < _contents.getLength(); i++) {
			if (_contents.item(i).getNodeType() == Node.ELEMENT_NODE) {
				org.w3c.dom.Element _element =
					(org.w3c.dom.Element) _contents.item(i);
				String _name = _element.getNodeName().trim();
				boolean _existPackage = false;

				if (_name.endsWith("Extension_Mechanisms.Stereotype")) {
					String _key = _element.getAttribute("xmi.id");
					org.w3c.dom.Node _nameElement =
						_element.getElementsByTagName(
							"Foundation.Core.ModelElement.name").item(
							0);
					String _value =
						_nameElement.getFirstChild().getNodeValue().trim();
					_Id2Stereotype.put(_key, _value);
				} else if (
					_name.endsWith("Core.DataType")
						|| _name.endsWith("Data_Types.Enumeration"))
					_primitif_types = primitifTypeTemplate(_element);

			}
		}

		for (int i = 0; i < _contents.getLength(); i++) {
			if (_contents.item(i).getNodeType() == Node.ELEMENT_NODE) {
				org.w3c.dom.Element _element =
					(org.w3c.dom.Element) _contents.item(i);
				String _name = _element.getNodeName().trim();
				boolean _existPackage = false;

				//le package
				if (_name.endsWith("Package")) {
					_package = packageTemplate(_element);
					_existPackage = true;
				} else if (_name.endsWith("Exception"))
					exceptionTemplate(_element, _package);
				for (int j = 0; j < _primitif_types.size(); j++) {
					org.omg.mof.Model.DataType _datatype =
						(org.omg.mof.Model.DataType) _primitif_types.elementAt(
							j);
					_datatype.set_container(_package);
					_package.add_contents(_datatype);
				}

			}

		}

		/* mettre les types, les tags  
			et les AssociationsEnds pour les rfrences 
			ainsi que les excepitons pourles oprations*/
		typing();
		associationEnds4Reference();
		putSupertypes();
		exceptions4Operations();
		taggedElement();
		return _package;	}

	// traitement du package
	public org.omg.mof.Model.Package packageTemplate(
		org.w3c.dom.Element _package_element)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		//cration par dfault du package
		org.omg.mof.Model.Package _package =
			_package_class.create_package(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false);

		// rcuprer les valeurs du pckage
		org.w3c.dom.NodeList _fils = _package_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name"))
				_package.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_package.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_package.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (
				_name.endsWith("Core.GeneralizableElement.isAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_abstract(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_leaf(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_package.set_is_root(true);
			} else if (_name.endsWith("Namespace.ownedElement")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();

				//traitements des associations d'abord 
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.Association"))
						associationTemplate(_element, _package);
					else if (_element_name.endsWith("Core.Class")) {
						org.w3c.dom.NodeList _childs = _element.getChildNodes();
						boolean _corba_type = false;
						int k = 0;
						while ((k < _childs.getLength()) && (!_corba_type)) {
							String _node = _childs.item(k).getNodeName();
							if (_node.endsWith("Core.ModelElement.stereotype"))
								_corba_type = true;
							k++;
						}

						if (!_corba_type)
							classTemplate(_element, _package);
						else {
							org.w3c.dom.Element _element_st =
								(org.w3c.dom.Element) _childs
									.item(k-1)
									.getFirstChild();
							String _id_st =
								_element_st.getAttribute("xmi.idref");
							String _stereotype =
								(String) _Id2Stereotype.get(_id_st);

							if (_stereotype.equalsIgnoreCase("CORBAEnum")
								|| _stereotype.equalsIgnoreCase("CORBAStruct"))
								dataTypeTemplate(_element, _package, false);
							else if (
								_stereotype.equalsIgnoreCase("CORBAConstant"))
								constantTemplate(_element, _package);
							else
								classTemplate(_element, _package);
						}
					} else if (
						_element_name.endsWith("Common_Behavior.Exception"))
						exceptionTemplate(_element, _package);
					else if (_element_name.endsWith("Tag"))
						tagTemplate(_element, _package);
				}
			}
		}

		// ranger le package dans la table des tags
		String _key = _package_element.getAttribute("xmi.id").trim();
		_elementHisTag.put(_key, _package);

		return _package;
	}

	//Traitement des classes
	public void classTemplate(
		org.w3c.dom.Element _class_element,
		org.omg.mof.Model.Namespace _container)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind {
		// rcuprer l'identificateur
		String _key = _class_element.getAttribute("xmi.id").trim();

		// cration d'une classe par dfault
		org.omg.mof.Model.Class _class =
			_class_class.create_class(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				false);

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _class_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name"))
				_class.set_name(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_class.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_class.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (
				_name.endsWith("Core.GeneralizableElement.isAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_abstract(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_leaf(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_class.set_is_root(true);
			} else if (_name.endsWith("Core.Classifier.associationEnd")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Node _element = _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.AssociationEnd")) {
						// rcuperer l'association End
						String _endKey_1 =
							((org.w3c.dom.Element) _element)
								.getAttribute("xmi.idref")
								.trim();

						//rcuperer le 2eme lment XML de l'asso End 
						String _endKey_2 = getOtherEnd(_endKey_1);

						org.w3c.dom.Element _endElement_2 =
							_document.getElementById(_endKey_2);

						//vrifier si c'est navigable
						String _isNavigable =
							((org.w3c.dom.Element) _endElement_2
								.getElementsByTagName("Foundation.Core.AssociationEnd.isNavigable")
								.item(0))
								.getAttribute("xmi.value")
								.trim();
						if (_isNavigable.endsWith("true"))
							referenceTemplate(_endElement_2, _class);
					}
				}
			} else if (
				_name.endsWith("Core.GeneralizableElement.generalization")) {
				java.util.Vector _supertypes_vector = new java.util.Vector();
				org.w3c.dom.NodeList _supertypes =
					_current.getElementsByTagName(
						"Foundation.Core.Generalization");
				for (int l = 0; l < _supertypes.getLength(); l++) {
					org.w3c.dom.Element _temp3 =
						(org.w3c.dom.Element) _supertypes.item(l);
					String _ref = _temp3.getAttribute("xmi.idref");
					//rcuprer l'association de gnralization
					org.w3c.dom.Element _generalization =
						_document.getElementById(_ref);

					// rcuperer la classe supertype 
					org.w3c.dom.Element _supertype =
						(org.w3c.dom.Element) _generalization
							.getElementsByTagName("Foundation.Core.Generalization.supertype")
							.item(0);
					String _idSupertype =
						(
							(org.w3c.dom.Element) _supertype
								.getFirstChild())
								.getAttribute(
							"xmi.idref");
					// rajouter la classe supertype 
					_supertypes_vector.addElement(_idSupertype);
				}
				_elementHisSupertypes.put(_class, _supertypes_vector);
			} else if (_name.endsWith("Namespace.ownedElement")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				//traitements des associations d'abord 
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.Class")) {
						org.w3c.dom.NodeList _childs = _element.getChildNodes();
						boolean _corba_type = false;
						int k = 0;
						while ((k< _childs.getLength()) && (!_corba_type)) {
							String _node = _childs.item(k).getNodeName();
							if (_node.endsWith("Core.ModelElement.stereotype"))
								_corba_type = true;
							k++;
						}

						if (!_corba_type)
							classTemplate(_element, _class);
						else {
							org.w3c.dom.Element _element_st =
								(org.w3c.dom.Element) _childs
									.item(k-1)
									.getFirstChild();
							String _id_st =
								_element_st.getAttribute("xmi.idref");
							String _stereotype =
								(String) _Id2Stereotype.get(_id_st);

							if (_stereotype.equalsIgnoreCase("CORBAEnum")
								|| _stereotype.equalsIgnoreCase("CORBAStruct"))
								dataTypeTemplate(_element, _class, false);
							else if (
								_stereotype.equalsIgnoreCase("CORBAConstant"))
								constantTemplate(_element, _class);
							else
								classTemplate(_element, _class);
						}
					} else if (
						_element_name.endsWith("Common_Behavior.Exception"))
						exceptionTemplate(_element, _class);
					else if (_element_name.endsWith("Tag"))
						tagTemplate(_element, _class);
				}
			} else if (_name.endsWith("Core.Classifier.feature")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.Attribute"))
						mofAttributeTemplate(_element, _class);
					else if (_element_name.endsWith("Core.Operation"))
						operationTemplate(_element, _class);
				}
			}
		}

		// container et contents
		_class.set_container(_container);
		_container.add_contents(_class);

		// ranger la classe dans la tables des types et ventuellement pour les tags
		_types.put(_key, _class);
		_elementHisTag.put(_key, _class);
	}

	public String getOtherEnd(String _endKey_1) {
		org.w3c.dom.Element _endElement_1 = _document.getElementById(_endKey_1);
		org.w3c.dom.Element _parentNode =
			(org.w3c.dom.Element) _endElement_1.getParentNode();
		String _endKey_2 = "";
		org.w3c.dom.NodeList _childs = _parentNode.getChildNodes();
		for (int i = 0; i < _childs.getLength(); i++) {
			org.w3c.dom.Element _current =
				(org.w3c.dom.Element) _childs.item(i);
			String _key = _current.getAttribute("xmi.id").trim();
			if (_key.compareTo(_endKey_1) != 0)
				_endKey_2 = _key;
		}
		return _endKey_2;
	}

	// les attributs d'une classe
	public void mofAttributeTemplate(
		org.w3c.dom.Element _attribute_element,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'un attribut par dfault
		org.omg.mof.Model.MofAttribute _attribute =
			_attribute_class.create_mof_attribute(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true,
				false);

		// rcuprer les valeurs de l'attribut
		org.w3c.dom.NodeList _fils = _attribute_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name"))
				_attribute.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_attribute.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_attribute.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("ownerScope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier"))
					_attribute.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("IsDerived")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_attribute.set_is_derived(true);
			} else if (_name.endsWith("changeable")) {
				String _changeable = _current.getAttribute("xmi.value").trim();
				if (_changeable.trim().endsWith("frozen"))
					_attribute.set_is_changeable(false);
			} else if (_name.endsWith("multiplicity")) {
				// les valeurs isUnique et is Ordered sont par dfaut  false  
				boolean _unique = false, _ordered = false;
				// recuperer les valeurs de la multiplicity
				int _lower, _upper;
				String _multiplicity =
					_current.getFirstChild().getNodeValue().trim();
				char lw = _multiplicity.charAt(0);
				char up = _multiplicity.charAt(3);

				_lower = Integer.valueOf(String.valueOf(lw)).intValue();
				if (String.valueOf(up).equalsIgnoreCase("*"))
					_upper = -1;
				else
					_upper = Integer.valueOf(String.valueOf(up)).intValue();

				// mettre  jour la multiplicity
				_attribute.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_ordered,
						_unique));
			} else if (_name.endsWith("StructuralFeature.type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_attribute, _ref);

			}
		}
		_attribute.set_container(_class);
		_class.add_contents(_attribute);
	}

	// les rfrences d'une classe
	public void referenceTemplate(
		org.w3c.dom.Element _endElement,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'une rfrence  par dfault
		//le nom est chang dans associationEnds4Reference
		org.omg.mof.Model.Reference _reference =
			_reference_class.create_reference(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true);

		// rcuprer les valeurs de l'association end correspondante
		org.w3c.dom.NodeList _fils = _endElement.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			// isOrdered
			boolean _isOrdered = false;
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_reference.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_reference.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("AssociationEnd.targetScope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier"))
					_reference.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("changeable")) {
				String _changeable = _current.getAttribute("xmi.value").trim();
				if (_changeable.trim().endsWith("frozen"))
					_reference.set_is_changeable(false);
			} else if (_name.endsWith("AssociationEnd.isOrdered")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_isOrdered = true;
			} else if (_name.endsWith("multiplicity")) {
				// isUnique est par dfaut false 
				boolean _isUnique = false;

				// recuperer les valeurs de la multiplicity
				int _lower, _upper;
				String _multiplicity =
					_current.getFirstChild().getNodeValue().trim();
				char lw = _multiplicity.charAt(0);
				char up = _multiplicity.charAt(3);

				_lower = Integer.valueOf(String.valueOf(lw)).intValue();
				if (String.valueOf(up).equalsIgnoreCase("*"))
					_upper = -1;
				else
					_upper = Integer.valueOf(String.valueOf(up)).intValue();
				// mettre  jour la multiplicity
				_reference.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_isOrdered,
						_isUnique));

			} else if (_name.endsWith("AssociationEnd.type")) {
				// le type est mis en correspondance avec le referencedEnd
			}
			String _ref = _endElement.getAttribute("xmi.id").trim();
			_referencedEndTable.put(_reference, _ref);

		}

		//container et contained
		_reference.set_container(_class);
		_class.add_contents(_reference);
	}

	// les oprations d'une classe
	public void operationTemplate(
		org.w3c.dom.Element _operation_element,
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {
		// cration d'un attribut par dfault
		org.omg.mof.Model.Operation _operation =
			_operation_class.create_operation(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				org.omg.mof.Model.ScopeKind.instance_level,
				true);

		// rcuprer les valeurs de la rfrence
		org.w3c.dom.NodeList _childs = _operation_element.getChildNodes();
		for (int i = 0; i < _childs.getLength(); i++) {
			org.w3c.dom.Element _current =
				(org.w3c.dom.Element) _childs.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name"))
				_operation.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_operation.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_operation.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("scope")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("classifier"))
					_operation.set_scope(
						org.omg.mof.Model.ScopeKind.classifier_level);
			} else if (_name.endsWith("isQuery")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_operation.set_is_query(false);
			} // traitement des paramtres
			else if (_name.endsWith("Core.BehavioralFeature.parameter")) {
				org.w3c.dom.NodeList _parameters = _current.getChildNodes();
				for (int j = 0; j < _parameters.getLength(); j++) {
					org.w3c.dom.Element _parameter =
						(org.w3c.dom.Element) _parameters.item(j);
					parameterTemplate(_parameter, _operation);
				}
			} else if (
				_name.endsWith("Core.BehavioralFeature.raisedException")) {
				// c'est trait dans par exceptions4Operations
			}
		}

		//Stocker l'opration pour lui affecter les exceptions
		_Id2Operation.put(
			_operation_element.getAttribute("xmi.id"),
			_operation);

		_operation.set_container(_class);
		_class.add_contents(_operation);
	}

	//traitement des paramtres d'oprations
	public void parameterTemplate(
		org.w3c.dom.Element _parameter_element,
		org.omg.mof.Model.Operation _operation)
		throws org.omg.mof.Reflective.MofError {
		// cration d'un paramtre par dfault
		org.omg.mof.Model.Parameter _parameter =
			_parameter_class.create_parameter(
				"name",
				"",
				new org.omg.mof.Model.MultiplicityType(1, 1, false, false),
				org.omg.mof.Model.DirectionKind.in_dir);

		// rcuprer les valeurs du paramtre
		org.w3c.dom.NodeList _childs = _parameter_element.getChildNodes();
		for (int k = 0; k < _childs.getLength(); k++) {
			org.w3c.dom.Element _child = (org.w3c.dom.Element) _childs.item(k);
			String _name_p = _child.getNodeName().trim();
			if (_name_p.endsWith("Core.ModelElement.name"))
				_parameter.set_name(
					_child.getFirstChild().getNodeValue().trim());
			else if (_name_p.endsWith("Core.Parameter.kind")) {
				String _direction = _child.getAttribute("xmi.value").trim();
				if (_direction.endsWith("out"))
					_parameter.set_direction(
						org.omg.mof.Model.DirectionKind.out_dir);
				else if (_direction.endsWith("inout"))
					_parameter.set_direction(
						org.omg.mof.Model.DirectionKind.inout_dir);
				else if (_direction.endsWith("return"))
					_parameter.set_direction(
						org.omg.mof.Model.DirectionKind.return_dir);
			} else if (_name_p.endsWith("Core.Parameter.type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _child.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_parameter, _ref);
			}
		}
		_operation.add_contents(_parameter);
		_parameter.set_container(_operation);
	}

	//traitement des exceptions
	public void exceptionTemplate(
		org.w3c.dom.Element _exception_element,
		org.omg.mof.Model.Namespace _container)
		throws org.omg.mof.Reflective.MofError {
		// cration d'une exception  par dfault
		org.omg.mof.Model.MofException _exception =
			_exception_class.create_mof_exception(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.private_vis,
				org.omg.mof.Model.ScopeKind.instance_level);

		// rcuprer les valeurs de l'exception
		org.w3c.dom.NodeList _childs = _exception_element.getChildNodes();
		for (int k = 0; k < _childs.getLength(); k++) {
			org.w3c.dom.Element _child = (org.w3c.dom.Element) _childs.item(k);
			String _name = _child.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.name"))
				_exception.set_name(
					_child.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _child.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_exception.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_exception.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (_name.endsWith("Exception.context")) {
				java.util.Vector _operations = new java.util.Vector();
				org.w3c.dom.NodeList _contents =
					_child.getElementsByTagName("Foundation.Core.Operation");
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _key_operation =
						_element.getAttribute("xmi.idref").trim();
					_operations.addElement(_key_operation);
				}
				// Stocker les exception afin de les lier aux oprations
				_Exception4Operations.put(_exception, _operations);
			}

			_container.add_contents(_exception);
			_exception.set_container(_container);
		}
	}

	//Traitement des associations
	public void associationTemplate(
		org.w3c.dom.Element _association_element,
		org.omg.mof.Model.Namespace _container)
		throws org.omg.mof.Reflective.MofError {

		// cration d'une classe par dfault
		org.omg.mof.Model.Association _association =
			_association_class.create_association(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				false);

		//Stocker les Id des associationEnds
		String[] _ends = new String[2];
		int k = 0;

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _association_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.name"))
				_association.set_name(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_association.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_association.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (
				_name.endsWith("Core.GeneralizableElement.isAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_abstract(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_leaf(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_association.set_is_root(true);
			} else if (_name.endsWith("Core.Association.connection")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.AssociationEnd")) {
						associationEndTemplate(_element, _association, k);
						_ends[k] = _element.getAttribute("xmi.id").trim();
						k++;
					}
				}
			}
		}

		// container et contents
		_association.set_container(_container);
		_container.add_contents(_association);

		// rajouer les association pour otherends
		_OtherEnd.put(_ends[0], _ends[1]);
		_OtherEnd.put(_ends[1], _ends[0]);

		//rajouter l'association dans la table des tags
		String _key = _association_element.getAttribute("xmi.id").trim();
		_types.put(_key, _association);
	}

	// les associations ends d'une classe
	public void associationEndTemplate(
		org.w3c.dom.Element _end_element,
		org.omg.mof.Model.Association _association,
		int k)
		throws org.omg.mof.Reflective.MofError {
		// cration de l'association end par dfault
		org.omg.mof.Model.AssociationEnd _association_end =
			_association_end_class.create_association_end(
				_association.name() + "_" + k,
				"",
				true,
				org.omg.mof.Model.AggregationKind.none,
				new org.omg.mof.Model.MultiplicityType(0, 1, false, false),
				true);

		// rcuprer les valeurs de l'association end
		org.w3c.dom.NodeList _fils = _end_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			// isOrdered
			boolean _isOrdered = false;
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.name")) {
				if (_current.hasChildNodes())
					_association_end.set_name(
						_current.getFirstChild().getNodeValue().trim());
			} else if (_name.endsWith("aggregation")) {
				String _aggregation = _current.getAttribute("xmi.value").trim();
				if (_aggregation.endsWith("shared"))
					_association_end.set_aggregation(
						org.omg.mof.Model.AggregationKind.shared);
				else if (_aggregation.endsWith("composite"))
					_association_end.set_aggregation(
						org.omg.mof.Model.AggregationKind.composite);
			} else if (_name.endsWith("isNavigable")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("false"))
					_association_end.set_is_navigable(false);
			} else if (_name.endsWith("changeable")) {
				String _changeable = _current.getAttribute("xmi.value").trim();
				if (_changeable.trim().endsWith("frozen"))
					_association_end.set_is_changeable(false);
			} else if (_name.endsWith("AssociationEnd.isOrdered")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_isOrdered = true;
			} else if (_name.endsWith("multiplicity")) {
				// isUnique est par dfaut false 
				boolean _isUnique = false;

				// recuperer les valeurs de la multiplicity
				int _lower, _upper;
				String _multiplicity =
					_current.getFirstChild().getNodeValue().trim();
				char lw = _multiplicity.charAt(0);
				char up = _multiplicity.charAt(3);

				_lower = Integer.valueOf(String.valueOf(lw)).intValue();
				if (String.valueOf(up).equalsIgnoreCase("*"))
					_upper = -1;
				else
					_upper = Integer.valueOf(String.valueOf(up)).intValue();
				// mettre  jour la multiplicity
				_association_end.set_multiplicity(
					new org.omg.mof.Model.MultiplicityType(
						_lower,
						_upper,
						_isOrdered,
						_isUnique));

			} else if (_name.endsWith("AssociationEnd.type")) {
				// le type
				org.w3c.dom.Element _type =
					(org.w3c.dom.Element) _current.getFirstChild();
				String _ref = _type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_association_end, _ref);
			}
		}
		// stocker
		String _key = _end_element.getAttribute("xmi.id").trim();
		_Id2End.put(_key, _association_end);

		// contents et container
		_association_end.set_container(_association);
		_association.add_contents(_association_end);
	}

	//Traitement des types primitifs 
	public java.util.Vector primitifTypeTemplate(
		org.w3c.dom.Element _datatype_element)
		throws org.omg.mof.Reflective.MofError {

		// le types de retour
		java.util.Vector _result = new java.util.Vector();

		// cration d'un DataType par dfault
		org.omg.mof.Model.DataType _datatype =
			_datatype_class.create_data_type(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any));

		// rcuprer les valeurs des attributs du Data Type
		org.w3c.dom.NodeList _fils = _datatype_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name")) {
				_datatype.set_name(
					"*" + _current.getFirstChild().getNodeValue().trim());
				//xml2TypeCode(_current, RepositoryID);
			} else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (
				_name.endsWith("Core.GeneralizableElement.isAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_abstract(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_leaf(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_root(true);
			}
		}
		// clacul de Type Code
		org.omg.CORBA.TypeCode _type_code = xml2TypeCode(_datatype.name());
		_datatype.set_type_code(_type_code);

		//stocker le type dans le vecteur 
		_result.addElement(_datatype);

		// ranger la classe dans la tables des types et ventuellement pour les tags
		// rcuprer l'identificateur
		String _key = _datatype_element.getAttribute("xmi.id").trim();
		_types.put(_key, _datatype);
		_elementHisTag.put(_key, _datatype);
		return _result;
	}

	//Traitement des Datatypes
	public void dataTypeTemplate(
		org.w3c.dom.Element _datatype_element,
		org.omg.mof.Model.Namespace _container,
		boolean _overlap)
		throws
			org.omg.mof.Reflective.MofError,
			org.omg.CORBA.TypeCodePackage.BadKind {

		// cration d'un DataType par dfault
		org.omg.mof.Model.DataType _datatype =
			_datatype_class.create_data_type(
				"name",
				"",
				org.omg.mof.Model.VisibilityKind.public_vis,
				false,
				false,
				false,
				_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any));

		// le nom du stereotype		
		String _corba_type = null;

		// rcuprer les valeurs des attributs du Data Type
		org.w3c.dom.NodeList _fils = _datatype_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("name")) {
				_datatype.set_name(
					_current.getFirstChild().getNodeValue().trim());
				//System.out.println(_current.getFirstChild().getNodeValue().trim());
			} else if (_name.endsWith("Core.ModelElement.visibility")) {
				String _visibility = _current.getAttribute("xmi.value").trim();
				if (_visibility.endsWith("protected"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.protected_vis);
				else if (_visibility.endsWith("private"))
					_datatype.set_visibility(
						org.omg.mof.Model.VisibilityKind.private_vis);
			} else if (
				_name.endsWith("Core.GeneralizableElement.isAbstract")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_abstract(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isLeaf")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_leaf(true);
			} else if (_name.endsWith("Core.GeneralizableElement.isRoot")) {
				String _boolean = _current.getAttribute("xmi.value").trim();
				if (_boolean.trim().endsWith("true"))
					_datatype.set_is_root(true);
			} else if (_name.endsWith("ModelElement.stereotype")) {
				String _id_type =
					((org.w3c.dom.Element) _current.getFirstChild())
						.getAttribute("xmi.idref")
						.trim();
				_corba_type = (String) _Id2Stereotype.get(_id_type);
			} else if (_name.endsWith("Namespace.ownedElement")) {
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _element_name = _element.getNodeName().trim();
					if (_element_name.endsWith("Core.Class")) {
						org.w3c.dom.NodeList _childs =
							_element.getElementsByTagName(
								"Foundation.Core.ModelElement.stereotype");
						if (_childs.getLength() != 0)
							dataTypeTemplate(_element, _datatype, true);
					}
				}
			}

			//traitement des champs des DataTypes complexes
			else if (_name.endsWith("Core.Classifier.feature")) {

				org.w3c.dom.NodeList _members =
					_current.getElementsByTagName("Foundation.Core.Attribute");
				// nombre des membres
				int length = _members.getLength();

				//calcul du Repository ID
				String RepositoryID =
					"IDL:" + Helper.format1(_container.name());
				if (_corba_type.compareTo("CORBAEnum") == 0) {

					//le nom de l'numration
					String RepID =
						RepositoryID + "/" + _datatype.name() + ":1.0";

					String[] _enum_members = new String[length];
					for (int j = 0; j < _members.getLength(); j++) {
						org.w3c.dom.Element _member =
							(org.w3c.dom.Element) _members.item(j);
						String _name_member =
							_member
								.getFirstChild()
								.getFirstChild()
								.getNodeValue()
								.trim();
						_enum_members[j] = _name_member;
					}
					_datatype.set_type_code(
						_orb.create_enum_tc(RepID, _name, _enum_members));

				} else if (_corba_type.compareTo("CORBAStruct") == 0) {

					//le nom de la structure
					String RepID =
						RepositoryID + "/" + _datatype.name() + ":1.0";

					org.omg.CORBA.StructMember[] _struct_members =
						new org.omg.CORBA.StructMember[length];

					for (int j = 0; j < _members.getLength(); j++) {
						org.w3c.dom.Element _member =
							(org.w3c.dom.Element) _members.item(j);
						org.omg.CORBA.StructMember _struct_member =
							new org.omg.CORBA.StructMember();

						org.w3c.dom.NodeList _att_contents =
							_member.getChildNodes();
						for (int k = 0; k < _att_contents.getLength(); k++) {
							org.w3c.dom.Element _element_att =
								(org.w3c.dom.Element) _att_contents.item(k);

							String _temp2 = _element_att.getNodeName().trim();
							if (_temp2.endsWith("Core.ModelElement.name")) {
								_struct_member.name =
									_element_att
										.getFirstChild()
										.getNodeValue()
										.trim();
							} else if (
								_temp2.endsWith(
									"Core.StructuralFeature.type")) {
								// le type
								org.w3c.dom.Element _type =
									(org.w3c.dom.Element) _element_att
										.getFirstChild();
								String _ref =
									_type.getAttribute("xmi.idref").trim();
								org.omg.CORBA.TypeCode _type_code =
									((org.omg.mof.Model.DataType) _types
										.get(_ref))
										.type_code();
								_struct_member.type = _type_code;
							}
						}
						_struct_members[j] = _struct_member;
					}

					_datatype.set_type_code(
						_orb.create_struct_tc(
							RepID,
							_datatype.name(),
							_struct_members));
				}
			}
		}

		// container et contents si c'est pas impriqu
		if (!_overlap) {
			_datatype.set_container(_container);
			_container.add_contents(_datatype);
		}

		// rcuprer l'identificateur
		String _key = _datatype_element.getAttribute("xmi.id").trim();
		_types.put(_key, _datatype);
		_elementHisTag.put(_key, _datatype);
	}

	//Traitement des constants
	public void constantTemplate(
		org.w3c.dom.Element _constant_element,
		org.omg.mof.Model.Namespace _namespace)
		throws org.omg.mof.Reflective.MofError {

		// cration d'un constant par dfault
		org.omg.mof.Model.Constant _constant =
			_constant_class.create_constant("name", "", _orb.create_any());

		//la valeur 
		String _id = _constant_element.getAttribute("xmi.id").trim();

		// rcuprer les valeurs de la constante
		org.w3c.dom.NodeList _fils = _constant_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.name"))
				_constant.set_name(
					_current.getFirstChild().getNodeValue().trim());

			else if (_name.endsWith("Core.Classifier.feature")) {

				// rcuprer l'attribut qui represente la consatante 
				org.w3c.dom.NodeList _contents =
					_current.getElementsByTagName("Foundation.Core.Attribute");
				org.w3c.dom.Element _attribute =
					(org.w3c.dom.Element) _contents.item(0);

				// rcuprer le type de l'attribut 				
				org.w3c.dom.Element _temp1 =
					(org.w3c.dom.Element) _attribute
						.getElementsByTagName("Foundation.Core.StructuralFeature.type")
						.item(0);
				org.w3c.dom.Element _element_type =
					(org.w3c.dom.Element) _temp1.getFirstChild();
				String _ref = _element_type.getAttribute("xmi.idref").trim();
				_elementHisType.put(_constant, _ref);

				//rcuprer la valeur de la constante 
				org.w3c.dom.Element _temp2 =
					(org.w3c.dom.Element) _attribute
						.getElementsByTagName("ndation.Core.Attribute.initialValue")
						.item(0);
				org.w3c.dom.Element _element_value =
					(org.w3c.dom.Element) _temp2
						.getElementsByTagName("Foundation.Data_Types.Expression.body")
						.item(0);
				String _value =
					_element_value.getFirstChild().getNodeValue().trim();
				_ConstantValue.put(_constant, _value);
			}
		}

		_constant.set_container(_namespace);
		_namespace.add_contents(_constant);
	}

	// traitement du Tag
	public void tagTemplate(
		org.w3c.dom.Element _tag_element,
		org.omg.mof.Model.Namespace _namespace)
		throws org.omg.mof.Reflective.MofError {

		// cration d'une classe par dfault
		org.omg.CORBA.Any[] _any_t = new org.omg.CORBA.Any[1];
		org.omg.CORBA.Any _mof_tag = _orb.create_any();
		_mof_tag.insert_string("");
		_any_t[0] = _mof_tag;
		org.omg.mof.Model.Tag _tag =
			_tag_class.create_tag("name", "", "", _any_t);

		// rcuprer les valeurs de la classe
		org.w3c.dom.NodeList _fils = _tag_element.getChildNodes();
		for (int i = 0; i < _fils.getLength(); i++) {
			org.w3c.dom.Element _current = (org.w3c.dom.Element) _fils.item(i);
			String _name = _current.getNodeName().trim();
			if (_name.endsWith("Core.ModelElement.name"))
				_tag.set_name(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Annotation"))
				_tag.set_annotation(
					_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("TagId"))
				_tag.set_tag_id(_current.getFirstChild().getNodeValue().trim());
			else if (_name.endsWith("Values")) {
				org.w3c.dom.Element _any_element =
					(org.w3c.dom.Element) _current.getElementsByTagName(
						"XMI.any").item(
						0);
				String _type = _any_element.getAttribute("xmi.type").trim();
				if (_type.endsWith("string")) {
					org.omg.CORBA.Any[] _any_tc = new org.omg.CORBA.Any[1];
					org.omg.CORBA.Any _mof_tag_c = _orb.create_any();
					_mof_tag_c.insert_string(
						_any_element.getFirstChild().getNodeValue().trim());
					_any_tc[0] = _mof_tag_c;
					_tag.set_values(_any_tc);
				}
			} else if (_name.endsWith("Elements")) {
				java.util.Vector _tagged_elements = new java.util.Vector();
				org.w3c.dom.NodeList _contents = _current.getChildNodes();
				for (int j = 0; j < _contents.getLength(); j++) {
					org.w3c.dom.Element _element =
						(org.w3c.dom.Element) _contents.item(j);
					String _key_element =
						_element.getAttribute("xmi.idref").trim();
					_tagged_elements.addElement(_key_element);
				}
				_tags.put(_tag, _tagged_elements);
			}
		}
		_tag.set_container(_namespace);
		_namespace.add_contents(_tag);
	} // passer de l'XML au Type code CORBA
	public org.omg.CORBA.TypeCode xml2TypeCode(String _name)
		throws org.omg.CORBA.BAD_TYPECODE {
		String _element_name = _name.substring(1).trim();
		org.omg.CORBA.TypeCode _typecode = null;
		if (_element_name.startsWith("boolean"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
		else if (_element_name.startsWith("octet"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet);
		else if (_element_name.startsWith("char"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_char);
		else if (_element_name.startsWith("wchar"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_wchar);
		else if (_element_name.startsWith("short"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_short);
		else if (_element_name.startsWith("unsigned short"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ushort);
		else if (_element_name.startsWith("long"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_long);
		else if (_element_name.startsWith("unsigned long"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
		else if (_element_name.startsWith("long long"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong);
		else if (_element_name.startsWith("unsigned long long"))
			_typecode =
				_orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulonglong);
		else if (_element_name.startsWith("double"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_double);
		else if (_element_name.startsWith("float"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_float);
		else if (_element_name.startsWith("any"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
		else if (_element_name.startsWith("string"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
		else if (_element_name.startsWith("wstring"))
			_typecode = _orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_string);
		return _typecode;
	} // typer les paramtres et les attributs et les constant
	public void typing()
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _elementHisType.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.TypedElement _typed_element =
				(org.omg.mof.Model.TypedElement) _keys.nextElement();
			// trouver la cl dans la deuxime table
			String _key = ((String) _elementHisType.get(_typed_element)).trim();
			// trouve le classifier
			org.omg.mof.Model.Classifier _classifier =
				(org.omg.mof.Model.Classifier) _types.get(_key);
			// typer
			_typed_element.set_type(_classifier);
			//System.out.print(_typed_element.name() + ", et son type est :");
			//System.out.println(_classifier.name());

			// affecter la valeur des constant
			if (_typed_element._is_a(org.omg.mof.Model.ConstantHelper.id())) {
				org.omg.mof.Model.Constant _constant =
					org.omg.mof.Model.ConstantHelper.narrow(_typed_element);
				String _value = (String) _ConstantValue.get(_constant);
				putConstantValue(_constant, _value);
			}
		}
	}

	//mettre les valeurs des constants
	public void putConstantValue(
		org.omg.mof.Model.Constant _constant,
		String _value)
		throws
			org.omg.CORBA.TypeCodePackage.BadKind,
			org.omg.mof.Reflective.MofError {
		org.omg.mof.Model.Classifier _classifier = _constant.type();
		if (_classifier._is_a(org.omg.mof.Model.DataTypeHelper.id())) {
			org.omg.mof.Model.DataType _datatype =
				org.omg.mof.Model.DataTypeHelper.narrow(_classifier);
			org.omg.CORBA.TypeCode _typecode = _datatype.type_code();
			org.omg.CORBA.Any _any = _orb.create_any();
			switch (_typecode.kind().value()) {
				case org.omg.CORBA.TCKind._tk_boolean :
					_any.insert_boolean(Boolean.valueOf(_value).booleanValue());
					break;
				case org.omg.CORBA.TCKind._tk_octet :

					_any.insert_octet(Byte.valueOf(_value).byteValue());
					break;
				case org.omg.CORBA.TCKind._tk_char :
					_any.insert_char(_value.charAt(0));
					break;
				case org.omg.CORBA.TCKind._tk_wchar :
					_any.insert_wchar(_value.charAt(0));
					break;
				case org.omg.CORBA.TCKind._tk_short :
					_any.insert_short(Short.valueOf(_value).shortValue());
					break;
				case org.omg.CORBA.TCKind._tk_ushort :
					_any.insert_ushort(Short.valueOf(_value).shortValue());
					break;
				case org.omg.CORBA.TCKind._tk_long :
					_any.insert_long(Integer.valueOf(_value).intValue());
					break;
				case org.omg.CORBA.TCKind._tk_ulong :
					_any.insert_ulong(Integer.valueOf(_value).intValue());
					break;
				case org.omg.CORBA.TCKind._tk_longlong :
					_any.insert_longlong(Long.valueOf(_value).longValue());
					break;
				case org.omg.CORBA.TCKind._tk_ulonglong :
					_any.insert_ulonglong(Long.valueOf(_value).longValue());
					break;
				case org.omg.CORBA.TCKind._tk_double :
					_any.insert_double(Double.valueOf(_value).doubleValue());
					break;
				case org.omg.CORBA.TCKind._tk_float :
					_any.insert_float(Float.valueOf(_value).floatValue());
					break;
				case org.omg.CORBA.TCKind._tk_string :
					_any.insert_string(_value.trim());
					break;
				case org.omg.CORBA.TCKind._tk_wstring :
					_any.insert_wstring(_value.trim());
					break;
				default :
					throw new org.omg.CORBA.TypeCodePackage.BadKind();
			}
			_constant.set_value(_any);
		}
	} //Mettre les supertypes  la fin
	private void putSupertypes() throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _elementHisSupertypes.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Class _class =
				(org.omg.mof.Model.Class) _keys.nextElement();
			// trouver la cl dans la deuxime table
			java.util.Vector _supertypes =
				((java.util.Vector) _elementHisSupertypes.get(_class));
			for (int i = 0; i < _supertypes.size(); i++) {
				String _key = ((String) _supertypes.elementAt(i)).trim();
				org.omg.mof.Model.Class _element =
					(org.omg.mof.Model.Class) _types.get(_key);
				_class.add_supertypes(_element);
			}
		}
	} // affecter les tags aux lments
	public void taggedElement() throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _tags.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Tag _tag =
				(org.omg.mof.Model.Tag) _keys.nextElement();
			// trouver la cl dans la deuxime table
			java.util.Vector _tagged_elements =
				(java.util.Vector) _tags.get(_tag);
			for (int i = 0; i < _tagged_elements.size(); i++) {
				String _key = ((String) _tagged_elements.elementAt(i)).trim();
				org.omg.mof.Model.ModelElement _element =
					(org.omg.mof.Model.ModelElement) _elementHisTag.get(_key);
				_tag.add_elements(_element);
			}
		}
	} // typage de les rfrence et les lier aux associationsEnds corrrespondantes
	public void associationEnds4Reference()
		throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _referencedEndTable.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.Reference _reference =
				(org.omg.mof.Model.Reference) _keys.nextElement();
			// Mettre exposedEnd
			String _refend_id = (String) _referencedEndTable.get(_reference);
			org.omg.mof.Model.AssociationEnd _ref_end =
				(org.omg.mof.Model.AssociationEnd) _Id2End.get(_refend_id);
			_reference.set_type(_ref_end.type());
			_reference.set_referenced_end(_ref_end);
			//Mettre le nom de la rfrence
			_reference.set_name(Helper.format2(_ref_end.name()));
			// Mettre exposedEnd
			String _expend_id = (String) _OtherEnd.get(_refend_id);
			org.omg.mof.Model.AssociationEnd _exp_end =
				(org.omg.mof.Model.AssociationEnd) _Id2End.get(_expend_id);
			_reference.set_exposed_end(_exp_end);
		}
	} // Affecter les exceptions pour les oprations
	public void exceptions4Operations()
		throws org.omg.mof.Reflective.MofError {
		java.util.Enumeration _keys = _Exception4Operations.keys();
		while (_keys.hasMoreElements()) {
			org.omg.mof.Model.MofException _exception =
				(org.omg.mof.Model.MofException) _keys.nextElement();
			// trouver la cl dans la deuxime table
			java.util.Vector _operations =
				(java.util.Vector) _Exception4Operations.get(_exception);
			for (int i = 0; i < _operations.size(); i++) {
				String _idOperation =
					((String) _operations.elementAt(i)).trim();
				org.omg.mof.Model.Operation _operation =
					(org.omg.mof.Model.Operation) _Id2Operation.get(
						_idOperation);
				_operation.add_exceptions(_exception);
				_exception.set_scope(_operation.scope());
			}
		}
	} // suprimer les noeuds qui contiennent du text vide
	public void delSpaces(org.w3c.dom.Node _node)
		throws
			org.xml.sax.SAXException,
			javax.xml.parsers.ParserConfigurationException,
			java.io.FileNotFoundException,
			java.io.IOException {

		org.w3c.dom.NodeList _fils = _node.getChildNodes();
		int i = 0;
		while (i < _fils.getLength()) {
			org.w3c.dom.Node _temp = _fils.item(i);
			if (_temp.getNodeType() == 3) {
				String _temp1 = _temp.getNodeValue();
				if (_temp1.trim().compareTo("") == 0)
					_node.removeChild(_temp);
				else
					i++;
			} else {
				delSpaces(_temp);
				i++;
			}
		}
	}
}