/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.lip6.src.modfact.util;


public class Helper {

	//normalisation des chaines MOF VI.3
	public static java.util.Vector splitAndDelete(String _input) {
		java.util.Vector parts = new java.util.Vector();
		String delim = "-_    .";
		java.util.StringTokenizer _sstring =
			new java.util.StringTokenizer(_input, delim);
		while (_sstring.hasMoreTokens()) {
			String part = _sstring.nextToken();
			int i = 0;
			int j = 0;
			boolean isPart = false;
			boolean beginPart = true;
			while (i < part.length()) {
				if (beginPart) {
					if ((Character.isDigit(part.charAt(i)))
						|| (Character.isUpperCase(part.charAt(i))))
						i++;
					else
						beginPart = false;
				} else {
					if ((Character.isDigit(part.charAt(i)))
						|| (Character.isLowerCase(part.charAt(i))))
						i++;
					else
						isPart = true;
				}
				if (isPart) {
					parts.addElement(part.substring(j, i));
					j = i;
					isPart = false;
					beginPart = true;
				}
				if (i == j)
					i++; //cas de caractre non spcif dans le filtre
			}
			if (i != j)
				parts.addElement(part.substring(j, i));
		}
		return parts;
	}

	//normalisation des chaines MOF Format 1
	public static String format1(String _input) {
		java.util.Vector s1 = splitAndDelete(_input);
		String buffer = " ";
		for (int i = 0; i < s1.size(); i++) {
			char[] s2 = s1.elementAt(i).toString().toCharArray();
			s2[0] = Character.toUpperCase(s1.elementAt(i).toString().charAt(0));
			String s3 = String.valueOf(s2);
			buffer = buffer.concat(s3);
		}
		return buffer.trim();
	}

	//normalisation des chaines MOF Format 1
	public static String format1Idl2JavaConflict(String _input) {
		java.util.Vector s1 = splitAndDelete(_input);
		String buffer = " ";
		for (int i = 0; i < s1.size(); i++) {
			char[] s2 = s1.elementAt(i).toString().toCharArray();
			s2[0] = Character.toUpperCase(s1.elementAt(i).toString().charAt(0));
			String s3 = String.valueOf(s2);
			buffer = buffer.concat(s3);
		}
		String format1 = buffer.trim();
		if (format1.matches("((.+(Package|Helper|Holder|Operations|POA|POATie)\\z)|(abstract|default|if|private|throw|boolean|do|mplements|protected|throws|break|double|import|public|transient|byte|else|instanceof|return|try|case|extends|int|short|void||catch|final|interface|static|volatilechar|finally|long|super|while|class|float|native|switch|const|for|new|synchronized|continue|goto|package|this|true|false|null|clone|equals|finalize|getClass|hashCode|notify|notifyAll|toString|wait))"))
			return "_" + format1;
		else
			return format1;
	}

	//normalisation des chianes MOF format 2
	public static String format2(String _input) {
		java.util.Vector s1 = splitAndDelete(_input);
		String buffer = " ";
		for (int i = 0; i < s1.size(); i++) {
			String s2 = s1.elementAt(i).toString().toLowerCase();
			buffer = buffer.concat(s2);
			if (i != (s1.size() - 1))
				buffer = buffer.concat("_");
		}

		return buffer.trim();
	}

	//normalisation des chianes MOF format 3
	public static String format3(String _input) {
		java.util.Vector s1 = splitAndDelete(_input);
		String buffer = " ";
		int i;
		for (i = 0; i < s1.size(); i++) {
			String s2 = s1.elementAt(i).toString().toUpperCase();
			buffer = buffer.concat(s2);
			if (i != (s1.size() - 1))
				buffer = buffer.concat("_");
		}
		return buffer.trim();
	}

	//test de contenance
	public static boolean contains(
		java.util.Vector _vector,
		org.omg.mof.Reflective.RefBaseObject _object) {
		if (_vector.size() == 0)
			return false;
		int i = 0;
		boolean _is_contained = false;
		while (!_is_contained && (i < _vector.size())) {
			org.omg.mof.Reflective.RefBaseObject _current =
				(org.omg.mof.Reflective.RefBaseObject) _vector.elementAt(i);
			if (_current.ref_itself(_object))
				_is_contained = true;
			else
				i++;
		}
		return _is_contained;
	}

	//L partie qui traite les TypesJava
	public static String idl2Java(String _type) {
		if (_type.equalsIgnoreCase("boolean"))
			return "boolean";
		else if (_type.equalsIgnoreCase("octet"))
			return "byte";
		else if (_type.equalsIgnoreCase("char"))
			return "char";
		else if (_type.equalsIgnoreCase("wchar"))
			return "char";
		else if (_type.equalsIgnoreCase("short"))
			return "Short";
		else if (_type.equalsIgnoreCase("unsigned short"))
			return "Short";
		else if (_type.equalsIgnoreCase("long"))
			return "int";
		else if (_type.equalsIgnoreCase("unsigned long"))
			return "int";
		else if (_type.equalsIgnoreCase("long long"))
			return "long";
		else if (_type.equalsIgnoreCase("unsigned long long"))
			return "long";
		else if (_type.equalsIgnoreCase("double"))
			return "double";
		else if (_type.equalsIgnoreCase("float"))
			return "float";
		else if (_type.equalsIgnoreCase("string"))
			return "String";
		else if (_type.equalsIgnoreCase("wstring"))
			return "String";
		else if (_type.equalsIgnoreCase("CORBA::TypeCode"))
			return "org.omg.CORBA.TypeCode";
		else if (_type.equalsIgnoreCase("any"))
			return "org.omg.CORBA.Any";
		else if (_type.equalsIgnoreCase("Object"))
			return "org.omg.CORBA.Object";
		// je pourrais dclacher une exception  revoir la igne ci-dessous
		else
			return _type;
	}

	// Dterminer le Type en Java
	public String javaType(org.omg.mof.Model.Classifier _classifier)
		throws org.omg.mof.Reflective.MofError {
		String _resu = _classifier.name();
		if (_resu.startsWith("*")) {
			_resu = idl2Java(_resu.substring(1));
			return _resu;
		} else {
			_resu = javaQualifiedName(_classifier);
			return _resu;
		}

	}

	//la valueur d'une constante 
	public String constantValue(org.omg.CORBA.Any _value)
		throws org.omg.CORBA.TypeCodePackage.BadKind {
		org.omg.CORBA.TypeCode _typecode = _value.type();
		switch (_typecode.kind().value()) {
			case org.omg.CORBA.TCKind._tk_boolean :
				return String.valueOf(_value.extract_boolean());

			case org.omg.CORBA.TCKind._tk_octet :
				return String.valueOf(
					(new Byte(_value.extract_octet())).toString());

			case org.omg.CORBA.TCKind._tk_char :
				return String.valueOf(_value.extract_char());

			case org.omg.CORBA.TCKind._tk_wchar :
				return String.valueOf(_value.extract_wchar());

			case org.omg.CORBA.TCKind._tk_short :
				return String.valueOf(
					(new Short(_value.extract_short())).toString());

			case org.omg.CORBA.TCKind._tk_ushort :
				return String.valueOf(
					(new Short(_value.extract_ushort())).toString());

			case org.omg.CORBA.TCKind._tk_long :
				return String.valueOf(_value.extract_long());

			case org.omg.CORBA.TCKind._tk_ulong :
				return String.valueOf(_value.extract_ulong());

			case org.omg.CORBA.TCKind._tk_longlong :
				return String.valueOf(_value.extract_longlong());

			case org.omg.CORBA.TCKind._tk_ulonglong :
				return String.valueOf(_value.extract_ulonglong());

			case org.omg.CORBA.TCKind._tk_double :
				return String.valueOf(_value.extract_double());

			case org.omg.CORBA.TCKind._tk_float :
				return String.valueOf(_value.extract_float());

			case org.omg.CORBA.TCKind._tk_string :
				return _value.extract_string();

			case org.omg.CORBA.TCKind._tk_wstring :
				return _value.extract_wstring();

			default :
				throw new org.omg.CORBA.TypeCodePackage.BadKind();
		}
	}

	//Drerminer le nom du package
	private java.util.Hashtable _table_package_name = new java.util.Hashtable();
	public String javaPackage(org.omg.mof.Model.Namespace _name_space)
		throws org.omg.mof.Reflective.MofError {

		// voir dans la table si c'est dja calcul
		String _key = _name_space.ref_mof_id();
		if (_table_package_name.containsKey(_key)) {
			String _package_name = (String) _table_package_name.get(_key);
			return _package_name;
		} else {
			//rajouter le nom du package "le prfixe mof "
			String _package_name = format1(_name_space.name());
			String _prefix = prefix(_name_space);
			if (_prefix != "")
				_package_name = _prefix + "." + _package_name;
			_table_package_name.put(_key, _package_name);
			return _package_name;

			/*String _temp1 = "." + format1(_name_space.name());
			_package_name = _package_name.substring(0, _package_name.lastIndexOf(_temp1));
			_table_package_name.put(_key, _package_name);
			return _package_name;*/
		}
	}

	// qualified Name : rattach le tableau qualified name
	private java.util.Hashtable _qualified_names = new java.util.Hashtable();
	public String qualifiedName(org.omg.mof.Model.ModelElement _modelelement)
		throws org.omg.mof.Reflective.MofError {
		String _key = _modelelement.ref_mof_id();
		if (_qualified_names.containsKey(_key)) {
			return (String) _qualified_names.get(_key);
		} else {
			String _attributeqname = "";
			String _name = _modelelement.name();
			if (_name.startsWith("*"))
				_attributeqname = _name.substring(1);
			else {
				String[] _qualified_name = _modelelement.qualified_name();
				for (int j = 0; j < _qualified_name.length; j++) {
					if (j > 0)
						_attributeqname =
							Helper.format1(_qualified_name[j])
								+ "."
								+ _attributeqname;
					else
						_attributeqname = Helper.format1(_qualified_name[j]);
				}
			}
			_qualified_names.put(_key, _attributeqname);
			return _attributeqname;
		}
	}

	private org.omg.mof.Model.ModelPackage _modelpackage;

	private String _prefix_mof = "";
	private String prefix(org.omg.mof.Model.Namespace _name_space)
		throws org.omg.mof.Reflective.MofError {
		if (_prefix_mof == "") {
			//Traitement eventuel du tag
			//Paris Xavier & Salim
			org.omg.mof.Model.Tag[] _tags =
				tagsOfPackage(
					org.omg.mof.Model.PackageHelper.narrow(_name_space));
			boolean end = false;
			int index = 0;
			while (!end && (index < _tags.length)) {
				org.omg.mof.Model.Tag _tag = _tags[index];
				org.omg.mof.Model.ModelElement[] _elements = _tag.elements();
				if (_elements[0].ref_itself(_name_space))
					end = true;
				else
					index++;
			}
			if (end) {
				org.omg.mof.Model.Tag _the_tag = _tags[index];
				if (_the_tag.tag_id().equals("org.omg.mof.idl_prefix")) {
					java.util.StringTokenizer _prefix_inv =
						new java.util.StringTokenizer(
							_the_tag.values()[0].extract_string(),
							".");
					String[] _temp = new String[_prefix_inv.countTokens()];
					for (int i = 0; i < _temp.length; i++)
						_temp[i] = _prefix_inv.nextToken();
					String _prefix = "";
					for (int i = _temp.length - 1; i > -1; i--) {
						_prefix = _prefix + _temp[i];
						if (i != 0)
							_prefix = _prefix + ".";
					}
					_prefix_mof = _prefix;
				}
			}
		}
		return _prefix_mof;
	}

	//Dterminer la notation pointe de Java
	private java.util.Hashtable _table_qualified_name =
		new java.util.Hashtable();
	public String javaQualifiedName(org.omg.mof.Model.Namespace _name_space)
		throws org.omg.mof.Reflective.MofError {

		// voir dans la table si c'est dja calcul
		String _key = _name_space.ref_mof_id();
		if (_table_qualified_name.containsKey(_key)) {
			String _qualified_name = (String) _table_qualified_name.get(_key);
			return _qualified_name;
		} else {
			boolean bool = false;
			String _namespacestring = format1(_name_space.name());
			org.omg.mof.Model.Namespace _current = _name_space;

			try {
				//commence par voir dja son contenaire si c'est pas le package
				if (!_current._is_a(org.omg.mof.Model.PackageHelper.id()))
					_current = _current.container();

				while (!bool) {
					if (_current._is_a(org.omg.mof.Model.ClassHelper.id())) {
						_namespacestring =
							format1Idl2JavaConflict(_current.name())
								+ "ClassPackage."
								+ _namespacestring;
						_current = _current.container();
						//rajouter le nom du package		
						if (_current
							._is_a(org.omg.mof.Model.PackageHelper.id()))
							_namespacestring =
								javaPackage(_current) + "." + _namespacestring;
					} else {
						if (_current
							._is_a(org.omg.mof.Model.DataTypeHelper.id())) {
							_namespacestring =
								format1Idl2JavaConflict(_current.name())
									+ "Package."
									+ _namespacestring;
							_current = _current.container();
							//rajouter le nom du package		
							if (_current
								._is_a(org.omg.mof.Model.PackageHelper.id()))
								_namespacestring =
									javaPackage(_current)
										+ "."
										+ _namespacestring;
						} else {
							//C'est un package donc calcluer le nom de la classe
							/*_namespacestring =
								format1Idl2JavaConflict(_current.name())
									+ "."
									+ _namespacestring;
							
							//rajouter le nom du package "le prfixe mof "
							String _prefix = prefix(_current);
							if (_prefix != "")
								_namespacestring =
									_prefix + "." + _namespacestring;*/
							bool = true;
						}
					}
				}
			} catch (org.omg.mof.Reflective.NotSet ex) {
			}
			_table_qualified_name.put(_key, _namespacestring);
			return _namespacestring;
		}
	}

	// Toutes les sous classes d'une classe dans package
	public org.omg.mof.Model.Class[] subClasses(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError, org.omg.mof.Reflective.NotSet {

		//rcuprer toutes les classes
		org.omg.mof.Model.Package _package =
			org.omg.mof.Model.PackageHelper.narrow(_class.container());

		//calcules les sous classes
		java.util.Vector _sub_classes = new java.util.Vector();
		java.util.Vector _all_classes = classesOfPackage(_package);

		for (int i = 0; i < _all_classes.size(); i++) {
			org.omg.mof.Model.Class _class_temp =
				(org.omg.mof.Model.Class) _all_classes.elementAt(i);
			java.util.Vector _all_type = new java.util.Vector();
			org.omg.mof.Model.GeneralizableElement[] _sup_classes =
				_class_temp.all_supertypes();
			for (int j = 0; j < _sup_classes.length; j++)
				_all_type.addElement(_sup_classes[j]);
			if (contains(_all_type, _class))
				//test du duplication
				if (!contains(_sub_classes, _class))
					_sub_classes.addElement(_class_temp);
		}
		org.omg.mof.Model.Class[] _return =
			new org.omg.mof.Model.Class[_sub_classes.size()];
		for (int i = 0; i < _sub_classes.size(); i++)
			_return[i] = (org.omg.mof.Model.Class) _sub_classes.elementAt(i);
		return _return;
	}

	//ordonner les classes
	private java.util.Hashtable _classes_ordonnees = new java.util.Hashtable();
	public java.util.Vector superClassesOrdered(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		String _key = _class.ref_mof_id();
		if (_classes_ordonnees.containsKey(_key)) {
			java.util.Vector _classes_vector =
				(java.util.Vector) _classes_ordonnees.get(_key);
			return _classes_vector;
		} else {
			org.omg.mof.Model.GeneralizableElement[] _all_superclasses =
				_class.all_supertypes();
			java.util.Vector _classes = new java.util.Vector();
			for (int i = 0; i < _all_superclasses.length; i++)
				_classes.addElement(
					org.omg.mof.Model.ClassHelper.narrow(_all_superclasses[i]));

			java.util.Vector _classes_vector = new java.util.Vector();
			while (_classes.size() != 0) {
				org.omg.mof.Model.Class _courant = null;
				for (int i = 0; i < _classes.size(); i++) {
					_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
					org.omg.mof.Model.GeneralizableElement[] _supertypes =
						_courant.supertypes();
					boolean _is_top = true;
					for (int j = 0; j < _supertypes.length; j++) {
						if (contains(_classes, _supertypes[j]))
							_is_top = false;
					}
					if (_is_top) {
						_classes_vector.addElement(_courant);
						_classes.removeElement(_courant);
					}
				}
			}

			_classes_vector.addElement(_class);
			_classes_ordonnees.put(_key, _classes_vector);
			return _classes_vector;
		}
	}

	//Calculer le contenu de chaque classes et les mettres dans des hashtable
	private java.util.Hashtable _classes_att_classifier =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_att_classifier_nd =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_att_instance =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_att_instance_nd =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_op_classifier =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_op_instance =
		new java.util.Hashtable();
	private java.util.Hashtable _classes_reference = new java.util.Hashtable();
	private java.util.Hashtable _classes_constant = new java.util.Hashtable();

	public void allContentsOfClasses(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		//calcul de la cl
		String _key = _class.ref_mof_id();

		java.util.Vector _attributes_classifier_nd = new java.util.Vector();
		java.util.Vector _attributes_classifier = new java.util.Vector();
		java.util.Vector _attributes_instance_nd = new java.util.Vector();
		java.util.Vector _attributes_instance = new java.util.Vector();
		java.util.Vector _operations_classifier = new java.util.Vector();
		java.util.Vector _operations_instance = new java.util.Vector();
		java.util.Vector _references = new java.util.Vector();
		java.util.Vector _constants = new java.util.Vector();

		org.omg.mof.Model.ModelElement[] _contents = _class.contents();
		for (int i = 0; i < _contents.length; i++) {
			// references
			if (_contents[i]._is_a(org.omg.mof.Model.ReferenceHelper.id())) {
				org.omg.mof.Model.Reference _reference =
					org.omg.mof.Model.ReferenceHelper.narrow(_contents[i]);
				if (_reference.visibility()
					== org.omg.mof.Model.VisibilityKind.public_vis)
					_references.addElement(_reference);
			}

			//attributes
			else if (
				_contents[i]._is_a(
					org.omg.mof.Model.MofAttributeHelper.id())) {
				org.omg.mof.Model.MofAttribute _attribute =
					org.omg.mof.Model.MofAttributeHelper.narrow(_contents[i]);
				if (_attribute.visibility()
					== org.omg.mof.Model.VisibilityKind.public_vis) {
					if (_attribute.scope()
						== org.omg.mof.Model.ScopeKind.classifier_level) {
						if (!_attribute.is_derived() == true)
							_attributes_classifier_nd.addElement(_attribute);
						_attributes_classifier.addElement(_attribute);
					} else {
						if (!_attribute.is_derived() == true)
							_attributes_instance_nd.addElement(_attribute);
						_attributes_instance.addElement(_attribute);
					}
				}
			}

			//operations
			else if (
				_contents[i]._is_a(org.omg.mof.Model.OperationHelper.id())) {
				org.omg.mof.Model.Operation _operation =
					org.omg.mof.Model.OperationHelper.narrow(_contents[i]);
				if (_operation.visibility()
					== org.omg.mof.Model.VisibilityKind.public_vis) {
					if (_operation.scope()
						== org.omg.mof.Model.ScopeKind.classifier_level)
						_operations_classifier.addElement(_operation);
					else
						_operations_instance.addElement(_operation);
				}
			}
			
			//constants
			else if (_contents[i]._is_a(org.omg.mof.Model.ConstantHelper.id())) {
				org.omg.mof.Model.Constant _constant = org.omg.mof.Model.ConstantHelper.narrow(_contents[i]);
				_constants.addElement(_constant);
			}
		}
		_classes_att_classifier.put(_key, _attributes_classifier);
		_classes_att_classifier_nd.put(_key, _attributes_classifier_nd);
		_classes_att_instance.put(_key, _attributes_instance);
		_classes_att_instance_nd.put(_key, _attributes_instance_nd);
		_classes_op_classifier.put(_key, _operations_classifier);
		_classes_op_instance.put(_key, _operations_instance);
		_classes_reference.put(_key, _references);
		_classes_constant.put(_key , _constants);
	}

	public java.util.Vector attributsForClass(
		org.omg.mof.Model.Class _class,
		org.omg.mof.Model.ScopeKind _scope,
		boolean _is_derived)
		throws org.omg.mof.Reflective.MofError {
		//Clacul de la cl
		String _key = _class.ref_mof_id();

		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level)) {
			if (!_is_derived) {
				java.util.Vector _attributs =
					(java.util.Vector) _classes_att_classifier.get(_key);
				return _attributs;
			} else {
				java.util.Vector _attributs =
					(java.util.Vector) _classes_att_classifier_nd.get(_key);
				return _attributs;
			}
		} else {
			if (!_is_derived) {
				java.util.Vector _attributs =
					(java.util.Vector) _classes_att_instance.get(_key);
				return _attributs;
			} else {
				java.util.Vector _attributs =
					(java.util.Vector) _classes_att_instance_nd.get(_key);
				return _attributs;
			}
		}
	}

	//toutes les attributs qui se trouve dans une classe et superclasses
	public java.util.Vector allAttributsForClasses(
		org.omg.mof.Model.Class _class,
		org.omg.mof.Model.ScopeKind _scope,
		boolean _test_of_derived)
		throws org.omg.mof.Reflective.MofError {

		//avoir toutes les classes
		java.util.Vector _all_classes = superClassesOrdered(_class);

		//crer le vecteur conteneur
		java.util.Vector _attributes_vector = new java.util.Vector();

		for (int i = 0; i < _all_classes.size(); i++) {

			//claculer la cl
			String _key =
				((org.omg.mof.Model.Class) _all_classes.elementAt(i))
					.ref_mof_id();

			if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level)) {
				if (!_test_of_derived) {
					java.util.Vector _temp =
						(java.util.Vector) _classes_att_classifier.get(_key);
					for (int j = 0; j < _temp.size(); j++)
						_attributes_vector.addElement(
							(org.omg.mof.Model.MofAttribute) _temp.elementAt(
								j));
				} else {
					java.util.Vector _temp =
						(java.util.Vector) _classes_att_classifier_nd.get(_key);
					for (int j = 0; j < _temp.size(); j++)
						_attributes_vector.addElement(
							(org.omg.mof.Model.MofAttribute) _temp.elementAt(
								j));
				}
			} else {
				if (!_test_of_derived) {
					java.util.Vector _temp =
						(java.util.Vector) _classes_att_instance.get(_key);
					for (int j = 0; j < _temp.size(); j++)
						_attributes_vector.addElement(
							(org.omg.mof.Model.MofAttribute) _temp.elementAt(
								j));
				} else {
					java.util.Vector _temp =
						(java.util.Vector) _classes_att_instance_nd.get(_key);
					for (int j = 0; j < _temp.size(); j++)
						_attributes_vector.addElement(
							(org.omg.mof.Model.MofAttribute) _temp.elementAt(
								j));
				}
			}
		}
		return _attributes_vector;
	}

	// Claculer toutes les oprations d'une classe
	public java.util.Vector operationsForClass(
		org.omg.mof.Model.Class _class,
		org.omg.mof.Model.ScopeKind _scope)
		throws org.omg.mof.Reflective.MofError {

		//Calcul de la cl
		String _key = _class.ref_mof_id();

		if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level)) {
			java.util.Vector _operations =
				(java.util.Vector) _classes_op_classifier.get(_key);
			return _operations;
		} else {
			java.util.Vector _operations =
				(java.util.Vector) _classes_op_instance.get(_key);
			return _operations;
		}
	}

	// toutes les oprations qui se trouve dans une classe et superclasses
	public java.util.Vector allOperationsForClasses(
		org.omg.mof.Model.Class _class,
		org.omg.mof.Model.ScopeKind _scope)
		throws org.omg.mof.Reflective.MofError {

		//avoir toutes les classes
		java.util.Vector _all_classes = superClassesOrdered(_class);

		//crer le vecteur conteneur
		java.util.Vector _operations_vector = new java.util.Vector();

		for (int i = 0; i < _all_classes.size(); i++) {

			//claculer la cl
			String _key =
				((org.omg.mof.Model.Class) _all_classes.elementAt(i))
					.ref_mof_id();
			if (_scope.equals(org.omg.mof.Model.ScopeKind.classifier_level)) {
				java.util.Vector _temp =
					(java.util.Vector) _classes_op_classifier.get(_key);
				for (int j = 0; j < _temp.size(); j++)
					_operations_vector.addElement(
						(org.omg.mof.Model.Operation) _temp.elementAt(j));
			} else {
				java.util.Vector _temp =
					(java.util.Vector) _classes_op_instance.get(_key);
				for (int j = 0; j < _temp.size(); j++)
					_operations_vector.addElement(
						(org.omg.mof.Model.Operation) _temp.elementAt(j));
			}
		}
		return _operations_vector;
	}

	// Claculer les rfrences non hrites d'une classe
	public java.util.Vector referencesForClass(org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		//Calcul de la cl
		String _key = _class.ref_mof_id();

		java.util.Vector _references =
			(java.util.Vector) _classes_reference.get(_key);
		return _references;
	}
	
	// Calculer les constants non hrites d'une classe
	public java.util.Vector constantsOfClass(org.omg.mof.Model.Class _class) throws org.omg.mof.Reflective.MofError {
		//Calcul de la cl
		String _key = _class.ref_mof_id();
		
		return (java.util.Vector) _classes_constant.get(_key);
	}

	// toutes les rfrences qui se trouve dans une classe et superclasses
	public java.util.Vector allReferencesForClasses(
		org.omg.mof.Model.Class _class)
		throws org.omg.mof.Reflective.MofError {

		//avoir toutes les classes
		java.util.Vector _all_classes = superClassesOrdered(_class);

		//crer le vecteur conteneur
		java.util.Vector _references_vector = new java.util.Vector();

		for (int i = 0; i < _all_classes.size(); i++) {
			//claculer la cl
			String _key =
				((org.omg.mof.Model.Class) _all_classes.elementAt(i))
					.ref_mof_id();

			java.util.Vector _temp =
				(java.util.Vector) _classes_reference.get(_key);
			for (int j = 0; j < _temp.size(); j++)
				_references_vector.addElement(
					(org.omg.mof.Model.Reference) _temp.elementAt(j));
		}
		return _references_vector;
	}

	// Asssociations Ends d'une association
	public org.omg.mof.Model.AssociationEnd[] associationEnds(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError {
		org.omg.mof.Model.AssociationEnd[] _ass =
			new org.omg.mof.Model.AssociationEnd[2];
		org.omg.mof.Model.ModelElement[] _cont = _association.contents();
		for (int i = 0; i < _cont.length; i++) {
			if (_cont[i]._is_a(org.omg.mof.Model.AssociationEndHelper.id()))
				_ass[i] =
					(org.omg.mof.Model.AssociationEndHelper.narrow(_cont[i]));
		}
		return _ass;

	}

	// les Classes contenues dans un package: ordonne
	private java.util.Hashtable _classes_of_package = new java.util.Hashtable();
	private java.util.Hashtable _packages_of_package =
		new java.util.Hashtable();
	private java.util.Hashtable _associations_of_package =
		new java.util.Hashtable();
	private java.util.Hashtable _imports_of_package = new java.util.Hashtable();
	private void contentsOfPackage(org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		String _key = _package.ref_mof_id();
		org.omg.mof.Model.ModelElement[] _contents = _package.contents();
		java.util.Vector _classes = new java.util.Vector();
		java.util.Vector _packages = new java.util.Vector();
		java.util.Vector _associations = new java.util.Vector();
		java.util.Vector _tags = new java.util.Vector();
		java.util.Vector _imports = new java.util.Vector();

		for (int i = 0; i < _contents.length; i++) {
			if (_contents[i]._is_a(org.omg.mof.Model.ClassHelper.id()))
				_classes.addElement(
					org.omg.mof.Model.ClassHelper.narrow(_contents[i]));
			else if (_contents[i]._is_a(org.omg.mof.Model.PackageHelper.id()))
				_packages.addElement(
					org.omg.mof.Model.PackageHelper.narrow(_contents[i]));
			else if (
				_contents[i]._is_a(org.omg.mof.Model.AssociationHelper.id()))
				_associations.addElement(
					org.omg.mof.Model.AssociationHelper.narrow(_contents[i]));
			else if (_contents[i]._is_a(org.omg.mof.Model.TagHelper.id()))
				_tags.addElement(
					org.omg.mof.Model.TagHelper.narrow(_contents[i]));
			else if (_contents[i]._is_a(org.omg.mof.Model.ImportHelper.id())) _imports.addElement(org.omg.mof.Model.ImportHelper.narrow(_contents[i]));
		}
		java.util.Vector _classes_ordered = new java.util.Vector();
		while (_classes.size() != 0) {
			org.omg.mof.Model.Class _courant = null;
			for (int i = 0; i < _classes.size(); i++) {
				_courant = (org.omg.mof.Model.Class) _classes.elementAt(i);
				org.omg.mof.Model.GeneralizableElement[] _supertypes =
					_courant.supertypes();
				boolean _is_top = true;
				for (int j = 0; j < _supertypes.length; j++) {
					if (contains(_classes, _supertypes[j]))
						_is_top = false;
				}
				if (_is_top) {
					_classes_ordered.addElement(_courant);
					_classes.removeElement(_courant);
				}
			}
		}
		_classes_of_package.put(_key, _classes_ordered);
		_packages_of_package.put(_key, _packages);
		_associations_of_package.put(_key, _associations);
		_tags_of_package.put(_key, _tags);
		_imports_of_package.put(_key , _imports);
	}

	// les Classes contenues dans un package: ordonne
	public java.util.Vector classesOfPackage(
		org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		String _key = _package.ref_mof_id();
		java.util.Vector _classes_vector = new java.util.Vector();
		if (_classes_of_package.containsKey(_key)) {
			_classes_vector = (java.util.Vector) _classes_of_package.get(_key);
			return _classes_vector;
		} else {
			contentsOfPackage(_package);
			_classes_vector = (java.util.Vector) _classes_of_package.get(_key);
		}
		return _classes_vector;
	}

	// les Classes contenues dans un package: ordonne
	public java.util.Vector packagesOfPackage(
		org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		String _key = _package.ref_mof_id();
		java.util.Vector _packages_vector = new java.util.Vector();
		if (_packages_of_package.containsKey(_key)) {
			_packages_vector =
				(java.util.Vector) _packages_of_package.get(_key);
			return _packages_vector;
		} else {
			contentsOfPackage(_package);
			_packages_vector =
				(java.util.Vector) _packages_of_package.get(_key);
		}
		return _packages_vector;
	}

	// les Asssociations contenues dans un package
	public java.util.Vector associationsOfPackage(
		org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		String _key = _package.ref_mof_id();
		java.util.Vector _associations_vector = new java.util.Vector();
		if (_packages_of_package.containsKey(_key)) {
			_associations_vector =
				(java.util.Vector) _associations_of_package.get(_key);
			return _associations_vector;
		} else {
			contentsOfPackage(_package);
			_associations_vector =
				(java.util.Vector) _associations_of_package.get(_key);
		}
		return _associations_vector;
	}

	public java.util.Vector importsOfPackage(org.omg.mof.Model.Package _package) throws org.omg.mof.Reflective.MofError {
		String key = _package.ref_mof_id();
		if (!_imports_of_package.containsKey(key)) contentsOfPackage(_package);
		return(java.util.Vector) _imports_of_package.get(key);
	}

	java.util.Hashtable _tags_of_package = new java.util.Hashtable();

	// les Tag contenus dans un package
	public org.omg.mof.Model.Tag[] tagsOfPackage(
		org.omg.mof.Model.Package _package)
		throws org.omg.mof.Reflective.MofError {
		String _key = _package.ref_mof_id();
		java.util.Vector _tags_vector = new java.util.Vector();
		if (_tags_of_package.containsKey(_key)) {
			_tags_vector = (java.util.Vector) _tags_of_package.get(_key);
		} else {
			contentsOfPackage(_package);
			_tags_vector = (java.util.Vector) _tags_of_package.get(_key);
		}
		//Convertir le vector en tableau
		org.omg.mof.Model.Tag[] res =
			new org.omg.mof.Model.Tag[_tags_vector.size()];
		for (int i = 0; i < _tags_vector.size(); i++)
			res[i] = (org.omg.mof.Model.Tag) _tags_vector.elementAt(i);
		return res;
	}

	// vrifier si une assoviation a des rfrences
	public org.omg.mof.Model.Reference[] getReferences(
		org.omg.mof.Model.Association _association)
		throws org.omg.mof.Reflective.MofError, org.omg.mof.Reflective.NotSet {

		java.util.Vector _temp = new java.util.Vector();

		//rcuprer le package contenuer de l'association
		org.omg.mof.Model.Package _package =
			org.omg.mof.Model.PackageHelper.narrow(_association.container());

		//rcuprer toutes les classes
		java.util.Vector _classes_of_package = new java.util.Vector();
		_classes_of_package = classesOfPackage(_package);

		//rcuprer les AssociationEnd
		org.omg.mof.Model.AssociationEnd[] _association_ends =
			associationEnds(_association);
		for (int i = 0; i < _classes_of_package.size(); i++) {
			org.omg.mof.Model.Class _class =
				(org.omg.mof.Model.Class) _classes_of_package.elementAt(i);

			//c'est dja clacul au paravant
			java.util.Vector _references = new java.util.Vector();
			_references = referencesForClass(_class);

			for (int j = 0; j < _references.size(); j++) {
				org.omg.mof.Model.Reference _reference =
					(org.omg.mof.Model.Reference) _references.elementAt(j);
				org.omg.mof.Model.AssociationEnd _association_end =
					_reference.referenced_end();
				// is_equivalent marche juste sur le Builder sinon sur le dos camarche equals
				if (_association_end._is_equivalent(_association_ends[0])
					|| _association_end._is_equivalent(_association_ends[1])) {
					_temp.addElement(_reference);
				}
			}
		}
		org.omg.mof.Model.Reference[] _referencees =
			new org.omg.mof.Model.Reference[_temp.size()];
		for (int i = 0; i < _referencees.length; i++)
			_referencees[i] = (org.omg.mof.Model.Reference) _temp.elementAt(i);
		return _referencees;
	}
	
	
	//JMI Stuff
	/**
	 * Return the JMI name of a package
	 */
	public String jmiPackageName(org.omg.mof.Model.Package _package) throws org.omg.mof.Reflective.MofError{
		return _package.name();
		//TODO
	}
	
	/**
	 * Return the JMI name of a package (be carefull, look at the TAG or maybe print an import)
	 */
	public String jmiQualifiedPackageName(org.omg.mof.Model.Package _package) throws org.omg.mof.Reflective.MofError{
		return _package.name();
		//TODO
	}
	
	/**
	 *  Return the JMI name of a class
	 */
	public String jmiClassName(org.omg.mof.Model.Class _class) throws org.omg.mof.Reflective.MofError{
		return _class.name();
		//TODO
	}

	/**
	 * Return the JMI name of an association
	 */
	public String jmiAssociationName(org.omg.mof.Model.Association _association) throws org.omg.mof.Reflective.MofError{
		return _association.name();
		//TODO
	}
	
	/**
	 * Return the JMI name of an attribute
	 */
	public String jmiAttributeName(org.omg.mof.Model.MofAttribute _attribute) throws org.omg.mof.Reflective.MofError{
		return _attribute.name();
		//TODO
	}
	
	/**
	 * Return the JMI name of a DataType
	 */
	public String jmiTypeCodeName(org.omg.CORBA.TypeCode _type) throws org.omg.CORBA.TypeCodePackage.BadKind  {
		return _type.name();
		//TODO
	}
	
	/**
	 * Return the JMI name of an Import
	 */
	public String jmiImportName(org.omg.mof.Model.Import _import) throws org.omg.mof.Reflective.MofError{
		return _import.name();
		//TODO
	}
	
	/**
	 * Return the JMI name of a Classifier (DataType or Class) 
	 */
	public String jmiClassifierName(org.omg.mof.Model.Classifier _classifier) throws org.omg.mof.Reflective.MofError{
		return _classifier.name();
		//TODO
	}
}