/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.trace.PI;


/**
 * Trace  Initializer.
 * used to Initialized CORBA Interceptor
 * 
 * @author <a href="mailto:offroy@lifl.fr">Jerome Offroy</a>
 */

public class Initializer extends org.omg.CORBA.LocalObject 
    implements org.omg.PortableInterceptor.ORBInitializer {
    /**
     * Trace slot id
     */
    private int trace_slot;

    private TraceCI clientInterceptor;
	private TraceSI serverInterceptor;

    /**
     * Pre initialization
     */
    public void pre_init(org.omg.PortableInterceptor.ORBInitInfo info) {
    }

    /**
     * Post initialization
     */
    public void post_init(org.omg.PortableInterceptor.ORBInitInfo info) {
        // allocation of the slot to use for Distributed TraceService        
        trace_slot = info.allocate_slot_id();

        clientInterceptor = new TraceCI(trace_slot, info);
        serverInterceptor = new TraceSI(trace_slot, info);

        try {
           info.add_client_request_interceptor(clientInterceptor);
           info.add_server_request_interceptor(serverInterceptor);
        } catch (org.omg.PortableInterceptor.ORBInitInfoPackage.DuplicateName dn) {
            System.out.println("Initializer, Duplicate name when adding the interceptor");
        }
    }
}